[![Build Status][badge-travis-image]][badge-travis-url]

# Kong StatsD Advanced Plugin


[badge-travis-url]: https://travis-ci.com/Kong/kong-plugin-statsd-advanced/branches
[badge-travis-image]: https://travis-ci.com/Kong/kong-plugin-statsd-advanced.svg?token=BfzyBZDa3icGPsKGmBHb&branch=master

Plugin documentation can be found [here](https://docs.konghq.com/hub/kong-inc/statsd-advanced/).

## Configuration

### Enabling the plugin on a Service

Configure this plugin on a Service by making the following request:

```bash
$ curl -X POST http://kong:8001/services/{service}/plugins \
    --data "name=statsd-advanced"  \
    --data "config.host=127.0.0.1" \
    --data "config.port=8125"
```

service: the id or name of the Service that this plugin configuration will target.

### Enabling the plugin on a Route

Configure this plugin on a Route with:

```bash
$ curl -X POST http://kong:8001/routes/{route_id}/plugins \
      --data "name=statsd-advanced"  \
      --data "config.host=127.0.0.1" \
      --data "config.port=8125"
```

route_id: the id of the Route that this plugin configuration will target.

### Enabling the plugin on a Consumer

You can use the http://localhost:8001/plugins endpoint to enable this plugin on specific Consumers:

```bash
curl -X POST http://kong:8001/plugins \
    --data "name=statsd-advanced" \
    --data "consumer_id={consumer_id}"  \
    --data "config.host=127.0.0.1" \
    --data "config.port=8125"
```

Where consumer_id is the id of the Consumer we want to associate with this plugin.

You can combine consumer_id and service_id in the same request, to furthermore narrow the scope of the plugin.

## Parameters

Form parameters | Default | Description
---|---|---
name | | The name of the plugin to use, in this case statsd-advanced
service_id | | The id of the Service which this plugin will target.
route_id | | Whether this plugin will be applied.
enabled | true |
consumer_id | | The id of the Consumer which this plugin will target.
config.host | 127.0.0.1 | The IP address or host name of StatsD server to send data to
config.port | 8125 | The port of StatsD server to send data to
config.metrics | All metrics are logged | List of Metrics to be logged. Available values are described under Metrics in [docs](https://docs.konghq.com/hub/kong-inc/statsd-advanced/).
config.prefix | kong | String to be prefixed to each metric’s name
config.udp_packet_size | 0 (not combined) | Combine UDP packet up to the size configured
config.use_tcp | false | Use TCP instead of UDP
