[![Build Status][badge-travis-image]][badge-travis-url]

# Kong Upstream Timeout Plugin

Overrides service-level timeouts when set on routes.

## Configuration

### Parameters
| Form parameter | description
|----------------|------------
| `conf.read_timeout` | Reading from upstream timeout threshold in milliseconds 
| `conf.send_timeout` | Send to upstream timeout threshold in milliseconds
| `conf.connect_timeout` | Connect to upstream timeout threshold in milliseconds

### Examples

Enabling the plugin on a route with `read_timeout` set will override any 
service-configured `read_timeout`. 

```
$ curl -X POST http://localhost:8001/routes/{route_id}/plugins \
    --data "name=upstream-timeout" \
    --data "config.read_timeout=4000"
```

[badge-travis-url]: https://travis-ci.com/Kong/kong-plugin-upstream-timeout/branches
[badge-travis-image]: https://travis-ci.com/Kong/kong-plugin-upstream-timeout.svg?token=BfzyBZDa3icGPsKGmBHb&branch=master

