-- This software is copyright Kong Inc. and its licensors.
-- Use of the software is subject to the agreement between your organization
-- and Kong Inc. If there is no such agreement, use is governed by and
-- subject to the terms of the Kong Master Software License Agreement found
-- at https://konghq.com/enterprisesoftwarelicense/.
-- [ END OF LICENSE 0867164ffc95e54f04670b5169c09574bdbd9bba ]

local _IterStack = {}


function _IterStack.new()
    local self = {}
    self.s = {}
    _IterStack.__index = _IterStack
    return setmetatable(self, _IterStack)
end


function _IterStack:push(iter)
    table.insert(self.s, iter)
end


function _IterStack:pop()
    return table.remove(self.s)
end


function _IterStack:peek()
    return self.s[#self.s]
end


function _IterStack:get_next()
    local iter = self:peek()
    if not iter then return nil end

    local next = iter()
    if not next then
        if self:pop() ~= nil then
            return self:get_next()
        end
        return nil
    end
    return next
end


return _IterStack
