-- This software is copyright Kong Inc. and its licensors.
-- Use of the software is subject to the agreement between your organization
-- and Kong Inc. If there is no such agreement, use is governed by and
-- subject to the terms of the Kong Master Software License Agreement found
-- at https://konghq.com/enterprisesoftwarelicense/.
-- [ END OF LICENSE 0867164ffc95e54f04670b5169c09574bdbd9bba ]

local SelectableNode = require "kong.gql.query.nodes.selectable_node"


local _FieldNode = SelectableNode:extend()


-- @param name: name of field
-- @param arguments: dictionary of key, value pairs
-- @param children: [SelectionNode]
function _FieldNode:new(name, arguments, selection_set, directives, alias)
    _FieldNode.super.new(self, name, selection_set, directives)
    self.arguments = arguments or {}
    self.alias = alias
end


function _FieldNode:__tostring()
    return string.format('FieldNode[%s]', self.alias or self.name)
end


return _FieldNode
