-- This software is copyright Kong Inc. and its licensors.
-- Use of the software is subject to the agreement between your organization
-- and Kong Inc. If there is no such agreement, use is governed by and
-- subject to the terms of the Kong Master Software License Agreement found
-- at https://konghq.com/enterprisesoftwarelicense/.
-- [ END OF LICENSE 0867164ffc95e54f04670b5169c09574bdbd9bba ]

local SelectableNode = require'kong.gql.query.nodes.selectable_node'

local _FragmentSpread = SelectableNode:extend()


function _FragmentSpread:new(name, directives)
    _FragmentSpread.super.new(self, name, nil, directives)
end


-- @param def: FragmentDefNode
function _FragmentSpread:link_def(def)
    self.def = def
end


function _FragmentSpread:children()
    return self.def:children(self)
end



-- Do not propagate depth further to its definition
function _FragmentSpread:propagate_depth(i)
    self.depth = i
end


function _FragmentSpread:__tostring()
    return string.format('FragmentSpread[%s]', self.name)
end


return _FragmentSpread
