-- This software is copyright Kong Inc. and its licensors.
-- Use of the software is subject to the agreement between your organization
-- and Kong Inc. If there is no such agreement, use is governed by and
-- subject to the terms of the Kong Master Software License Agreement found
-- at https://konghq.com/enterprisesoftwarelicense/.
-- [ END OF LICENSE 0867164ffc95e54f04670b5169c09574bdbd9bba ]

local sha2 = require "resty.nettle.sha2"


local rand = math.random


local algs = {
  "S256",
  "S384",
  "S512",
}

local hash = {
  S256 = sha2.sha256,
  S384 = sha2.sha384,
  S512 = sha2.sha512,
}


local n = #algs


function hash.none(s)
  return s
end


function hash.random(s)
  return hash[algs[rand(n)]](s)
end


return hash
