-- This software is copyright Kong Inc. and its licensors.
-- Use of the software is subject to the agreement between your organization
-- and Kong Inc. If there is no such agreement, use is governed by and
-- subject to the terms of the Kong Master Software License Agreement found
-- at https://konghq.com/enterprisesoftwarelicense/.
-- [ END OF LICENSE 0867164ffc95e54f04670b5169c09574bdbd9bba ]

local utils = require "kong.tools.utils"


local _M = {}


function _M.rt_rename(_, _, dao)
  local plugins, err = dao.plugins:find_all({ name = "request-transformer" })
  if err then
    return err
  end

  for i = 1, #plugins do
    local plugin = plugins[i]
    local _, err = dao.plugins:insert({
      name = "request-transformer-advanced",
      api_id = plugin.api_id,
      consumer_id = plugin.consumer_id,
      enabled = plugin.enabled,
      config = utils.deep_copy(plugin.config),
    })
    if err then
      return err
    end

    -- drop the old entry
    local _, err = dao.plugins:delete(plugin, { quite = true })
    if err then
      return err
    end
  end
end


return _M

