webpackJsonp([0],{

/***/ 109:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var DEFAULT_TIMEOUT = 5000;

exports.default = {
  data: function data() {
    return {
      toaster: {
        appearance: 'success',
        message: ''
      },
      successToaster: {
        appearance: 'success',
        message: 'success',
        timeoutMilliseconds: DEFAULT_TIMEOUT
      },
      errorToaster: {
        appearance: 'danger',
        message: 'error',
        timeoutMilliseconds: DEFAULT_TIMEOUT
      },
      isToasterVisible: false
    };
  },


  methods: {
    showToaster: function showToaster(toasterConfig) {
      this.isToasterVisible = true;
      this.toaster = toasterConfig;
    },
    closeToaster: function closeToaster() {
      this.isToasterVisible = false;
    }
  }
};

/***/ }),

/***/ 126:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.INPUT_FIELDS = exports.PLUGINS = exports.FILENAMES = exports.TYPES = exports.ROUTES = undefined;

var _defineProperty2 = __webpack_require__(127);

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _INPUT_FIELDS;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ROUTES = {
  files: 'files',
  unauthenticatedFiles: 'files/unauthenticated',
  notFound: '404',
  register: 'register'
};

var TYPES = {
  PARTIAL: 'partial',
  PAGE: 'page',
  SPEC: 'spec'
};

var FILENAMES = {
  LOGIN_UNAUTHENTICATED: 'unauthenticated/login'
};

var PLUGINS = {
  BASIC_AUTH: 'basic-auth',
  KEY_AUTH: 'key-auth',
  OPENID_CONNECT: 'openid-connect'
};

var INPUT_FIELDS = (_INPUT_FIELDS = {}, (0, _defineProperty3.default)(_INPUT_FIELDS, PLUGINS.BASIC_AUTH, 'password'), (0, _defineProperty3.default)(_INPUT_FIELDS, PLUGINS.KEY_AUTH, 'key'), (0, _defineProperty3.default)(_INPUT_FIELDS, PLUGINS.OPENID_CONNECT, 'email'), _INPUT_FIELDS);

exports.ROUTES = ROUTES;
exports.TYPES = TYPES;
exports.FILENAMES = FILENAMES;
exports.PLUGINS = PLUGINS;
exports.INPUT_FIELDS = INPUT_FIELDS;

/***/ }),

/***/ 17:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.location = undefined;

var _keys = __webpack_require__(48);

var _keys2 = _interopRequireDefault(_keys);

var _stringify = __webpack_require__(68);

var _stringify2 = _interopRequireDefault(_stringify);

var _typeof2 = __webpack_require__(196);

var _typeof3 = _interopRequireDefault(_typeof2);

exports.renderError = renderError;
exports.getWorkspaceURL = getWorkspaceURL;
exports.getMetaTagContent = getMetaTagContent;
exports.sortAlphabetical = sortAlphabetical;
exports.isObject = isObject;
exports.stripTrailingSlash = stripTrailingSlash;
exports.getCurrentRoute = getCurrentRoute;
exports.navigateToHome = navigateToHome;
exports.navigateToUrl = navigateToUrl;
exports.decodeItem = decodeItem;
exports.encodeItem = encodeItem;
exports.forEach = forEach;
exports.getUrlParameter = getUrlParameter;
exports.addEvent = addEvent;
exports.recursiveErrorObjToString = recursiveErrorObjToString;
exports.getMessageFromError = getMessageFromError;
exports.capitalize = capitalize;
exports.transformMetaFields = transformMetaFields;

var _config = __webpack_require__(42);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function renderError(el, error) {
  el.classList.add('error');
  el.innerHTML = error;
}

function getWorkspaceURL(url) {
  var route = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  var workspacePath = '/' + (0, _config.GET_CONFIG)('WORKSPACE');
  var routePath = route[0] === '/' ? route : '/' + route;

  if (workspacePath === '/default' || workspacePath === '/') {
    return '' + url + routePath;
  }

  return '' + url + workspacePath + routePath;
}

function getMetaTagContent(name, defaultValue, dom) {
  dom = dom != null ? dom : document;
  if (!dom) {
    return defaultValue;
  }

  var elements = dom.getElementsByName(name);
  var content = elements.length ? elements[0].content : defaultValue;
  var resp = content === '' || content && content.indexOf('{{') > -1 ? defaultValue : content;
  if (resp === 'null') {
    return '';
  }
  return resp;
}

function sortAlphabetical(a, b) {
  if (a < b) {
    return -1;
  } else if (a > b) {
    return 1;
  }
  return 0;
}

function isObject(item) {
  return (typeof item === 'undefined' ? 'undefined' : (0, _typeof3.default)(item)) === 'object' && !Array.isArray(item) && item !== null;
}

function stripTrailingSlash(string) {
  return string.slice(-1) === '/' ? string.slice(0, -1) : string;
}

function getCurrentRoute() {
  var initialRoute = window.location.pathname.slice(1) === '' ? 'index' : window.location.pathname.slice(1);
  var routeToLoad = stripTrailingSlash(initialRoute);
  return routeToLoad;
}

var location = exports.location = {
  setLocationHref: function setLocationHref(newHref) {
    window.location.href = newHref;
  },

  getLocationHref: function getLocationHref() {
    return window.location.href;
  }
};

function navigateToHome() {
  var url = (0, _config.GET_CONFIG_URL)('GUI');
  location.setLocationHref(url);
}

function navigateToUrl(url) {
  location.setLocationHref(url);
}

function decodeItem(item) {
  var decoded = void 0;

  try {
    decoded = atob(item);
    if (decoded && item) {
      return JSON.parse(decoded);
    }
  } catch (e) {
    return {};
  }

  return {};
}

function encodeItem(item) {
  return btoa((0, _stringify2.default)(item));
}

function forEach(array, callback, scope) {
  for (var i = 0; i < array.length; i++) {
    callback.call(scope, i, array[i]);
  }
}

function getUrlParameter(name) {
  name = name.replace(/[[]/, '\\[').replace(/[\]]/, '\\]');
  var regex = new RegExp('[\\?&]' + name + '=([^&#]*)');
  var results = regex.exec(window.location.search);
  return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
}

function addEvent(parent, evt, selector, handler) {
  parent.addEventListener(evt, function (event) {
    if (event.target.matches(selector + ', ' + selector + ' *')) {
      handler.apply(event.target.closest(selector), arguments);
    }
  }, false);
}

function recursiveErrorObjToString(obj) {
  var str = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  return (0, _keys2.default)(obj).reduce(function (acc, key) {
    if (key === 'code') {
      return acc;
    }

    var value = obj[key];
    if ((typeof value === 'undefined' ? 'undefined' : (0, _typeof3.default)(value)) === 'object' && value !== null) {
      return recursiveErrorObjToString(value, acc);
    }

    return '' + (acc && acc + ', ') + key + ': ' + value;
  }, str);
}

function getMessageFromError(error) {
  if (error.response && error.response.data) {
    if (error.response.data.message) {
      return error.response.data.message;
    }

    return recursiveErrorObjToString(error.response.data);
  }

  return error.message || 'There was an error';
}

var capitalizeRegEx = /(?:^|[\s-:'"])\w/g;

function capitalize(str) {
  return str.replace(capitalizeRegEx, function (a) {
    return a.toUpperCase();
  });
}

window.getMessageFromError = getMessageFromError;

function transformMetaFields(jsonStringMetaFields) {
  var schemaToConfigValidatorMap = {
    string: 'text',
    number: 'number'
  };
  var metaFields = jsonStringMetaFields.map(function (field) {
    return {
      field_name: field.title,
      input: field.label,
      type_of_input: field.is_email ? 'email' : schemaToConfigValidatorMap[field.validator.type],
      required: field.validator.required
    };
  });
  return metaFields;
}

/***/ }),

/***/ 1831:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _vue = __webpack_require__(60);

var _vue2 = _interopRequireDefault(_vue);

var _App = __webpack_require__(1832);

var _App2 = _interopRequireDefault(_App);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

window.registerApp(function () {
  if (window.document.getElementById('portal-dashboard')) {
    window._kong.dashboard = new _vue2.default({
      el: '#portal-dashboard',
      data: {},
      template: '<App/>',
      components: { App: _App2.default }
    });
  }
});

/***/ }),

/***/ 1832:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_App_vue__ = __webpack_require__(743);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_App_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_App_vue__);
/* harmony namespace reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_App_vue__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_App_vue__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_04878599_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_App_vue__ = __webpack_require__(1997);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__ = __webpack_require__(31);
var disposed = false
function injectStyle (context) {
  if (disposed) return
  __webpack_require__(1833)
}
/* script */


/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = injectStyle
/* scopeId */
var __vue_scopeId__ = "data-v-04878599"
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null

var Component = Object(__WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__["a" /* default */])(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_App_vue___default.a,
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_04878599_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_App_vue__["a" /* render */],
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_04878599_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_App_vue__["b" /* staticRenderFns */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src/js/dashboard/App.vue"

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-04878599", Component.options)
  } else {
    hotAPI.reload("data-v-04878599", Component.options)
  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["default"] = (Component.exports);


/***/ }),

/***/ 1833:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(1834);
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var add = __webpack_require__(30).default
var update = add("53a312bc", content, false, {});
// Hot Module Replacement
if(false) {
 // When the styles change, update the <style> tags
 if(!content.locals) {
   module.hot.accept("!!../../../node_modules/css-loader/index.js!../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-04878599\",\"scoped\":true,\"sourceMap\":false}!../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./App.vue", function() {
     var newContent = require("!!../../../node_modules/css-loader/index.js!../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-04878599\",\"scoped\":true,\"sourceMap\":false}!../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./App.vue");
     if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
     update(newContent);
   });
 }
 // When the module is disposed, remove the <style> tags
 module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 1834:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(27)(undefined);
// imports


// module
exports.push([module.i, "\nh1[data-v-04878599], h2[data-v-04878599] {\n  font-weight: 500;\n  color: rgba(0,0,0,.7);\n}\nh1[data-v-04878599] {\n  font-size: 35px;\n}\nh2[data-v-04878599] {\n  font-size: 21px;\n}\n#dashboard-wrapper[data-v-04878599] {\n  max-width: 1120px;\n  width: 100%;\n  margin: 24px auto;\n  padding: 0 1rem;\n}\n", ""]);

// exports


/***/ }),

/***/ 1836:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_Dashboard_vue__ = __webpack_require__(744);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_Dashboard_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_Dashboard_vue__);
/* harmony namespace reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_Dashboard_vue__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_Dashboard_vue__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_0ac8e981_hasScoped_false_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_Dashboard_vue__ = __webpack_require__(1973);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__ = __webpack_require__(31);
var disposed = false
function injectStyle (context) {
  if (disposed) return
  __webpack_require__(1837)
}
/* script */


/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = injectStyle
/* scopeId */
var __vue_scopeId__ = null
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null

var Component = Object(__WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__["a" /* default */])(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_Dashboard_vue___default.a,
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_0ac8e981_hasScoped_false_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_Dashboard_vue__["a" /* render */],
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_0ac8e981_hasScoped_false_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_Dashboard_vue__["b" /* staticRenderFns */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src/js/dashboard/pages/Dashboard.vue"

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-0ac8e981", Component.options)
  } else {
    hotAPI.reload("data-v-0ac8e981", Component.options)
  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["default"] = (Component.exports);


/***/ }),

/***/ 1837:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(1838);
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var add = __webpack_require__(30).default
var update = add("0dd0f066", content, false, {});
// Hot Module Replacement
if(false) {
 // When the styles change, update the <style> tags
 if(!content.locals) {
   module.hot.accept("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"scoped\":false,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./Dashboard.vue", function() {
     var newContent = require("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"scoped\":false,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./Dashboard.vue");
     if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
     update(newContent);
   });
 }
 // When the module is disposed, remove the <style> tags
 module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 1838:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(27)(undefined);
// imports


// module
exports.push([module.i, "\n.empty-credentials-wrapper {\n  display: flex;\n  flex-direction: column;\n  align-items: center;\n  justify-content: center;\n  padding: 2rem 0;\n  margin: 24px 0;\n  background: rgba(0, 0, 0, 0.03);\n}\n.empty-credentials-wrapper h3 {\n    margin-bottom: .5rem;\n    font-size: 17px;\n    font-weight: normal;\n    color: rgba(0, 0, 0, 0.7);\n}\n.empty-credentials-wrapper p {\n    margin: 0 0 1rem;\n}\n", ""]);

// exports


/***/ }),

/***/ 1839:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialTable_vue__ = __webpack_require__(745);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialTable_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialTable_vue__);
/* harmony namespace reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialTable_vue__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialTable_vue__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_0009d6b6_hasScoped_false_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_CredentialTable_vue__ = __webpack_require__(1860);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__ = __webpack_require__(31);
var disposed = false
function injectStyle (context) {
  if (disposed) return
  __webpack_require__(1840)
}
/* script */


/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = injectStyle
/* scopeId */
var __vue_scopeId__ = null
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null

var Component = Object(__WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__["a" /* default */])(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialTable_vue___default.a,
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_0009d6b6_hasScoped_false_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_CredentialTable_vue__["a" /* render */],
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_0009d6b6_hasScoped_false_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_CredentialTable_vue__["b" /* staticRenderFns */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src/js/dashboard/components/CredentialTable.vue"

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-0009d6b6", Component.options)
  } else {
    hotAPI.reload("data-v-0009d6b6", Component.options)
  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["default"] = (Component.exports);


/***/ }),

/***/ 1840:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(1841);
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var add = __webpack_require__(30).default
var update = add("fbfd9166", content, false, {});
// Hot Module Replacement
if(false) {
 // When the styles change, update the <style> tags
 if(!content.locals) {
   module.hot.accept("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"scoped\":false,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./CredentialTable.vue", function() {
     var newContent = require("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"scoped\":false,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./CredentialTable.vue");
     if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
     update(newContent);
   });
 }
 // When the module is disposed, remove the <style> tags
 module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 1841:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(27)(undefined);
// imports


// module
exports.push([module.i, "\n.table-header {\n  display: flex;\n  align-items: center;\n  margin-bottom: 1rem;\n}\n.table-header button {\n    font-size: 1rem;\n    padding: .25rem 1rem .5rem;\n    margin-left: auto;\n    color: rgba(0, 0, 0, 0.7);\n    border-radius: 0.25rem;\n    border-color: rgba(0, 0, 0, 0.12);\n    background-color: #f5f5f5;\n    transition: all 0.2s ease-in-out;\n    cursor: pointer;\n}\n.table-header button span {\n      color: #0A7BCC;\n      font-weight: 800;\n}\n.table-header button:hover {\n      color: rgba(0, 0, 0, 0.85);\n      border-color: rgba(0, 0, 0, 0.25);\n}\n.table-header button:active {\n      color: rgba(0, 0, 0, 0.7);\n      background-color: gainsboro;\n}\n.credential-list {\n  margin-bottom: 36px;\n}\n.credential-table {\n  overflow-x: auto;\n}\n.credential-table tbody {\n    border-bottom: 1px solid #dee2e6;\n}\n.credential-table .table-actions {\n    display: flex;\n    align-items: center;\n    justify-content: flex-end;\n}\n.credential-table .table-actions a {\n      color: #2978CA;\n      cursor: pointer;\n}\n.credential-table .table-actions a:not(:last-child) {\n        margin: 0 1rem;\n}\n.credential-table .table-actions a:hover {\n        text-decoration: underline;\n}\n.credential-table .table-actions svg {\n      cursor: pointer;\n      transition: all 300ms ease;\n}\n.credential-table .table-actions svg:hover path {\n        fill: #E67E7E;\n}\n.credential-table .modal-dialog p {\n    font-size: 15px;\n    color: rgba(0, 0, 0, 0.7);\n}\n.credential-table .modal-dialog p strong {\n      color: rgba(0, 0, 0, 0.85);\n}\n.credential-table .modal-dialog p.light {\n      color: rgba(0, 0, 0, 0.45);\n}\n.empty-credentials-wrapper {\n  display: flex;\n  flex-direction: column;\n  align-items: center;\n  justify-content: center;\n  padding: 2rem 0;\n  background: rgba(0, 0, 0, 0.03);\n}\n.empty-credentials-wrapper h3 {\n    margin-bottom: .5rem;\n    font-size: 17px;\n    font-weight: normal;\n    color: rgba(0, 0, 0, 0.7);\n}\n.empty-credentials-wrapper p {\n    margin: 0 0 1rem;\n}\n", ""]);

// exports


/***/ }),

/***/ 1842:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(1843);
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var add = __webpack_require__(30).default
var update = add("fd990cee", content, false, {});
// Hot Module Replacement
if(false) {
 // When the styles change, update the <style> tags
 if(!content.locals) {
   module.hot.accept("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-2f81d49e\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./CredentialFormModal.vue", function() {
     var newContent = require("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-2f81d49e\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./CredentialFormModal.vue");
     if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
     update(newContent);
   });
 }
 // When the module is disposed, remove the <style> tags
 module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 1843:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(27)(undefined);
// imports


// module
exports.push([module.i, "\nbutton[data-v-2f81d49e] {\n  margin-top: 16px;\n}\n", ""]);

// exports


/***/ }),

/***/ 1850:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(1851);
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var add = __webpack_require__(30).default
var update = add("2eed6239", content, false, {});
// Hot Module Replacement
if(false) {
 // When the styles change, update the <style> tags
 if(!content.locals) {
   module.hot.accept("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"scoped\":false,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./CredentialForm.vue", function() {
     var newContent = require("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"scoped\":false,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./CredentialForm.vue");
     if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
     update(newContent);
   });
 }
 // When the module is disposed, remove the <style> tags
 module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 1851:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(27)(undefined);
// imports


// module
exports.push([module.i, "\n.field:not(:first-child) {\n  padding-top: 16px;\n}\n.field p {\n  margin: 2px 0;\n  font-size: 13px;\n  letter-spacing: 0;\n  line-height: 20px;\n}\n.field p:not(.helper) {\n    text-transform: capitalize;\n}\n.field p.helper {\n    font-size: 13px;\n    color: rgba(0, 0, 0, 0.45);\n    font-style: italic;\n}\n.field p.error {\n    margin-top: 5px;\n    font-weight: 600;\n    color: #f2110d;\n    font-size: 13px;\n    font-style: italic;\n}\n.field .btn-danger {\n  color: #f2110d;\n  cursor: pointer;\n}\n.field .btn-danger:hover {\n    text-decoration: underline;\n}\n.field .field-title {\n  color: #262626;\n}\n.field .field-description {\n  color: rgba(0, 0, 0, 0.45);\n}\n.field select {\n  border: 1px solid #D7D7D7;\n  border-radius: 3px;\n  background: #F5F5F5;\n  color: #4D4D4D;\n  font-size: 14px;\n  padding: 6px 0;\n  width: 100%;\n  height: 36px;\n}\n.field input {\n  height: 36px;\n  font-size: 14px;\n  color: #4D4D4D;\n  margin: 0;\n}\n.field input.hasError {\n    border-color: #f2110d;\n    background: rgba(242, 17, 13, 0.1);\n}\n.field input:disabled {\n    background-color: #d9d9d9;\n}\n.field textArea {\n  border-radius: 3px;\n  border: 1px solid #D7D7D7;\n  line-height: 36px;\n  font-size: 14px;\n  width: 100%;\n  color: #4D4D4D;\n  margin: 0;\n}\n", ""]);

// exports


/***/ }),

/***/ 1852:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return render; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return staticRenderFns; });
var render = function() {
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c(
    "form",
    {
      on: {
        submit: function($event) {
          $event.preventDefault()
          return _vm.validateAndSubmit($event)
        },
        keyup: function($event) {
          if (
            !("button" in $event) &&
            _vm._k($event.keyCode, "enter", 13, $event.key, "Enter")
          ) {
            return null
          }
          return _vm.validateAndSubmit($event)
        }
      }
    },
    [
      _vm._t("pre-field-content"),
      _vm._v(" "),
      _vm._l(_vm.schema.fields, function(field, key) {
        return _c("div", { key: key, staticClass: "field" }, [
          field.type === "input" &&
          (field.inputType === "text" ||
            field.inputType === "array" ||
            field.inputType === "number")
            ? _c("div", [
                _c("p", [_vm._v(_vm._s(field.label || key))]),
                _vm._v(" "),
                field.inputType === "checkbox"
                  ? _c("input", {
                      directives: [
                        {
                          name: "model",
                          rawName: "v-model",
                          value: _vm.model[key],
                          expression: "model[key]"
                        }
                      ],
                      attrs: {
                        id: key,
                        name: key,
                        disabled: _vm.isDisabled,
                        type: "checkbox"
                      },
                      domProps: {
                        checked: Array.isArray(_vm.model[key])
                          ? _vm._i(_vm.model[key], null) > -1
                          : _vm.model[key]
                      },
                      on: {
                        change: function($event) {
                          var $$a = _vm.model[key],
                            $$el = $event.target,
                            $$c = $$el.checked ? true : false
                          if (Array.isArray($$a)) {
                            var $$v = null,
                              $$i = _vm._i($$a, $$v)
                            if ($$el.checked) {
                              $$i < 0 &&
                                _vm.$set(_vm.model, key, $$a.concat([$$v]))
                            } else {
                              $$i > -1 &&
                                _vm.$set(
                                  _vm.model,
                                  key,
                                  $$a.slice(0, $$i).concat($$a.slice($$i + 1))
                                )
                            }
                          } else {
                            _vm.$set(_vm.model, key, $$c)
                          }
                        }
                      }
                    })
                  : field.inputType === "radio"
                  ? _c("input", {
                      directives: [
                        {
                          name: "model",
                          rawName: "v-model",
                          value: _vm.model[key],
                          expression: "model[key]"
                        }
                      ],
                      attrs: {
                        id: key,
                        name: key,
                        disabled: _vm.isDisabled,
                        type: "radio"
                      },
                      domProps: { checked: _vm._q(_vm.model[key], null) },
                      on: {
                        change: function($event) {
                          _vm.$set(_vm.model, key, null)
                        }
                      }
                    })
                  : _c("input", {
                      directives: [
                        {
                          name: "model",
                          rawName: "v-model",
                          value: _vm.model[key],
                          expression: "model[key]"
                        }
                      ],
                      attrs: {
                        id: key,
                        name: key,
                        disabled: _vm.isDisabled,
                        type: field.inputType
                      },
                      domProps: { value: _vm.model[key] },
                      on: {
                        input: function($event) {
                          if ($event.target.composing) {
                            return
                          }
                          _vm.$set(_vm.model, key, $event.target.value)
                        }
                      }
                    })
              ])
            : _vm._e(),
          _vm._v(" "),
          field.type === "input" && field.inputType === "password"
            ? _c("div", [
                _vm.inEditMode
                  ? _c("div", [
                      _c(
                        "a",
                        {
                          staticClass: "btn btn-danger",
                          on: {
                            click: function($event) {
                              _vm.isPasswordVisible = !_vm.isPasswordVisible
                            }
                          }
                        },
                        [
                          !_vm.isPasswordVisible
                            ? _c("span", [_vm._v("Change Password")])
                            : _vm._e()
                        ]
                      )
                    ])
                  : _vm._e(),
                _vm._v(" "),
                _vm.isPasswordVisible
                  ? _c("div", [
                      _c("p", [_vm._v(_vm._s(field.label || key))]),
                      _vm._v(" "),
                      _c("input", {
                        directives: [
                          {
                            name: "model",
                            rawName: "v-model",
                            value: _vm.model[key],
                            expression: "model[key]"
                          }
                        ],
                        attrs: {
                          id: key,
                          type: "password",
                          name: "password",
                          disabled: _vm.isDisabled
                        },
                        domProps: { value: _vm.model[key] },
                        on: {
                          input: function($event) {
                            if ($event.target.composing) {
                              return
                            }
                            _vm.$set(_vm.model, key, $event.target.value)
                          }
                        }
                      }),
                      _vm._v(" "),
                      _vm.inEditMode
                        ? _c("div", { staticClass: "field" }, [
                            _c("p", [_vm._v("Confirm Password")]),
                            _vm._v(" "),
                            _c("input", {
                              directives: [
                                {
                                  name: "model",
                                  rawName: "v-model",
                                  value: _vm.passwordConfirm,
                                  expression: "passwordConfirm"
                                }
                              ],
                              class: { hasError: _vm.hasError },
                              attrs: {
                                id: "passwordConfirm",
                                type: "password",
                                name: "password-confirm",
                                disabled: _vm.isDisabled
                              },
                              domProps: { value: _vm.passwordConfirm },
                              on: {
                                input: function($event) {
                                  if ($event.target.composing) {
                                    return
                                  }
                                  _vm.passwordConfirm = $event.target.value
                                }
                              }
                            }),
                            _vm._v(" "),
                            _vm.hasError
                              ? _c("p", { staticClass: "error" }, [
                                  _vm._v("Password must match previous entry")
                                ])
                              : _vm._e(),
                            _vm._v(" "),
                            _c("p", { staticClass: "helper" }, [
                              _vm._v(
                                "WARNING: By changing this password, even leaving it blank will update your existing password. This cannot be undone."
                              )
                            ])
                          ])
                        : _vm._e()
                    ])
                  : _vm._e()
              ])
            : _vm._e(),
          _vm._v(" "),
          field.type === "textArea"
            ? _c("div", [
                _c("p", [_vm._v(_vm._s(field.label || key))]),
                _vm._v(" "),
                _c("textarea", {
                  directives: [
                    {
                      name: "model",
                      rawName: "v-model",
                      value: _vm.model[key],
                      expression: "model[key]"
                    }
                  ],
                  staticClass: "field-input textarea",
                  attrs: { rows: field.rows, disabled: _vm.isDisabled },
                  domProps: { value: _vm.model[key] },
                  on: {
                    input: function($event) {
                      if ($event.target.composing) {
                        return
                      }
                      _vm.$set(_vm.model, key, $event.target.value)
                    }
                  }
                })
              ])
            : _vm._e(),
          _vm._v(" "),
          field.type === "select"
            ? _c("div", [
                _c("p", [_vm._v(_vm._s(field.label || key))]),
                _vm._v(" "),
                _c(
                  "select",
                  {
                    directives: [
                      {
                        name: "model",
                        rawName: "v-model",
                        value: _vm.model[key],
                        expression: "model[key]"
                      }
                    ],
                    staticClass: "field-input select",
                    on: {
                      change: function($event) {
                        var $$selectedVal = Array.prototype.filter
                          .call($event.target.options, function(o) {
                            return o.selected
                          })
                          .map(function(o) {
                            var val = "_value" in o ? o._value : o.value
                            return val
                          })
                        _vm.$set(
                          _vm.model,
                          key,
                          $event.target.multiple
                            ? $$selectedVal
                            : $$selectedVal[0]
                        )
                      }
                    }
                  },
                  _vm._l(field.values, function(value) {
                    return _c(
                      "option",
                      {
                        key: value,
                        attrs: { disabled: _vm.isDisabled },
                        domProps: { value: value }
                      },
                      [_vm._v(_vm._s(value))]
                    )
                  })
                )
              ])
            : _vm._e()
        ])
      }),
      _vm._v(" "),
      _vm._t("post-field-content")
    ],
    2
  )
}
var staticRenderFns = []
render._withStripped = true

if (false) {
  module.hot.accept()
  if (module.hot.data) {
    require("vue-hot-reload-api")      .rerender("data-v-1297d7e8", { render: render, staticRenderFns: staticRenderFns })
  }
}

/***/ }),

/***/ 1853:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return render; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return staticRenderFns; });
var render = function() {
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c(
    "div",
    [
      _c(
        "KModal",
        { attrs: { isVisible: _vm.isVisible }, on: { close: _vm.closeModal } },
        [
          _c("template", { slot: "header-content" }, [
            _vm.actionType === "create"
              ? _c("span", [_vm._v("Create API Credential")])
              : _vm._e(),
            _vm._v(" "),
            _vm.actionType === "edit"
              ? _c("span", [_vm._v("Edit API Credential")])
              : _vm._e()
          ]),
          _vm._v(" "),
          _c(
            "template",
            { slot: "body-content" },
            [
              _c(
                "CredentialForm",
                {
                  attrs: {
                    model: _vm.formModel,
                    actionType: _vm.actionType,
                    schema: _vm.formSchema,
                    triggerSubmit: _vm.triggerSubmit,
                    onSubmit: _vm.submitModal
                  }
                },
                [
                  _c("template", { slot: "pre-field-content" }, [
                    _vm.actionType !== "edit"
                      ? _c("div", { staticClass: "field" }, [
                          _c("p", { staticClass: "field-title" }, [
                            _vm._v("Select the Credential Type:")
                          ]),
                          _vm._v(" "),
                          _c(
                            "select",
                            {
                              directives: [
                                {
                                  name: "model",
                                  rawName: "v-model",
                                  value: _vm.formType,
                                  expression: "formType"
                                }
                              ],
                              staticClass: "field-input select",
                              attrs: { id: "auth-types", name: "auth-types" },
                              on: {
                                change: function($event) {
                                  var $$selectedVal = Array.prototype.filter
                                    .call($event.target.options, function(o) {
                                      return o.selected
                                    })
                                    .map(function(o) {
                                      var val =
                                        "_value" in o ? o._value : o.value
                                      return val
                                    })
                                  _vm.formType = $event.target.multiple
                                    ? $$selectedVal
                                    : $$selectedVal[0]
                                }
                              }
                            },
                            _vm._l(_vm.plugins, function(cred, key) {
                              return _c(
                                "option",
                                { key: key, domProps: { value: cred.plugin } },
                                [
                                  _vm._v(
                                    "\n                " +
                                      _vm._s(cred.name) +
                                      "\n              "
                                  )
                                ]
                              )
                            })
                          )
                        ])
                      : _vm._e()
                  ])
                ],
                2
              )
            ],
            1
          ),
          _vm._v(" "),
          _c(
            "template",
            { slot: "footer-actions" },
            [
              _vm.actionType === "create"
                ? _c(
                    "KButton",
                    {
                      attrs: {
                        appearance: "primary",
                        isRounded: true,
                        handleClick: _vm.submitForm,
                        buttonAttributes: _vm.submitButtonAttributes
                      }
                    },
                    [_vm._v("\n        Create API Credential\n      ")]
                  )
                : _vm._e(),
              _vm._v(" "),
              _vm.actionType === "edit"
                ? _c(
                    "KButton",
                    {
                      attrs: {
                        appearance: "primary",
                        isRounded: true,
                        handleClick: _vm.submitForm,
                        buttonAttributes: _vm.submitButtonAttributes
                      }
                    },
                    [_vm._v("\n        Edit API Credential\n      ")]
                  )
                : _vm._e()
            ],
            1
          ),
          _vm._v(" "),
          _c(
            "template",
            { slot: "footer-dismiss" },
            [
              _c(
                "KButton",
                {
                  attrs: {
                    appearance: "secondary",
                    isRounded: true,
                    handleClick: _vm.closeModal,
                    id: "closeButton"
                  }
                },
                [_vm._v("\n        Cancel\n      ")]
              )
            ],
            1
          )
        ],
        2
      )
    ],
    1
  )
}
var staticRenderFns = []
render._withStripped = true

if (false) {
  module.hot.accept()
  if (module.hot.data) {
    require("vue-hot-reload-api")      .rerender("data-v-2f81d49e", { render: render, staticRenderFns: staticRenderFns })
  }
}

/***/ }),

/***/ 1860:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return render; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return staticRenderFns; });
var render = function() {
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c("div", { staticClass: "credential-list" }, [
    _c("div", { staticClass: "table-header" }, [
      _c("h3", [_vm._v(_vm._s(_vm.credentialOptions.title))])
    ]),
    _vm._v(" "),
    _c(
      "div",
      { staticClass: "credential-table" },
      [
        _vm.credentialList.data.length
          ? _c("KTable", {
              attrs: { options: _vm.credentialList, hasHover: true },
              scopedSlots: _vm._u([
                {
                  key: "actions",
                  fn: function(ref) {
                    var row = ref.row
                    var rowKey = ref.rowKey
                    return [
                      _c("div", { staticClass: "table-actions" }, [
                        _c(
                          "a",
                          {
                            on: {
                              click: function($event) {
                                _vm.showModal("edit", row, rowKey)
                              }
                            }
                          },
                          [_vm._v("Edit")]
                        ),
                        _vm._v(" "),
                        _c(
                          "a",
                          {
                            attrs: { id: "trashcan" },
                            on: {
                              click: function($event) {
                                _vm.showModal("delete", row, rowKey)
                              }
                            }
                          },
                          [
                            _c(
                              "svg",
                              {
                                attrs: {
                                  width: "14",
                                  height: "16",
                                  xmlns: "http://www.w3.org/2000/svg"
                                }
                              },
                              [
                                _c("path", {
                                  attrs: {
                                    d:
                                      "M3 3V2c0-1.1045695.8954305-2 2-2h4c1.1045695 0 2 .8954305 2 2v1h2c.5522847 0 1 .4477153 1 1v1H0V4c0-.5522847.4477152-1 1-1h2zm2 0V2h4v1H5zM1 6h2v8h8V6h2v8c0 1.1045695-.8954305 2-2 2H3c-1.1045695 0-2-.8954305-2-2V6zm5 0v7c-.5522847 0-1-.4477153-1-1V7c0-.5522847.4477153-1 1-1zm2 0c.5522847 0 1 .4477153 1 1v5c0 .5522847-.4477153 1-1 1V6z",
                                    fill: "#BFBFBF",
                                    "fill-rule": "evenodd"
                                  }
                                })
                              ]
                            )
                          ]
                        )
                      ])
                    ]
                  }
                }
              ])
            })
          : _c("div", { staticClass: "empty-credentials-wrapper" }, [
              _c("h3", [
                _vm._v(
                  "Create " +
                    _vm._s(_vm.credentialOptions.title) +
                    " Credentials"
                )
              ]),
              _vm._v(" "),
              _c("p", [_vm._v('Click "Create API Credential" to get started.')])
            ]),
        _vm._v(" "),
        _vm.selectedRow && _vm.selectedRow.modal === "edit"
          ? _c("CredentialFormModal", {
              attrs: {
                plugins: [_vm.credentialOptions],
                authType: _vm.credentialOptions.plugin,
                actionType: _vm.selectedRow.modal,
                model: _vm.selectedRow.credential,
                submitModalCallback: _vm.updateCredential,
                isVisible: _vm.selectedRow.modal === "edit"
              },
              on: { close: _vm.closeModal }
            })
          : _vm._e(),
        _vm._v(" "),
        _vm.selectedRow
          ? _c(
              "KModal",
              {
                attrs: { isVisible: _vm.selectedRow.modal === "delete" },
                on: { close: _vm.closeModal }
              },
              [
                _c("template", { slot: "header-content" }, [
                  _vm._v("Delete API Credential")
                ]),
                _vm._v(" "),
                _c("template", { slot: "body-content" }, [
                  _c("p", [
                    _vm._v("Are you sure you want to delete "),
                    _c("strong", [_vm._v(_vm._s(_vm.selectedRow.name))])
                  ]),
                  _vm._v(" "),
                  _c("p", { staticClass: "light" }, [
                    _vm._v(
                      "After deletion the applications or services using that API credential are going to stop working."
                    )
                  ])
                ]),
                _vm._v(" "),
                _c(
                  "template",
                  { slot: "footer-actions" },
                  [
                    _c(
                      "KButton",
                      {
                        attrs: {
                          appearance: "danger",
                          handleClick: _vm.deleteCredential
                        }
                      },
                      [_vm._v("Delete API Credential")]
                    )
                  ],
                  1
                )
              ],
              2
            )
          : _vm._e(),
        _vm._v(" "),
        _c(
          "KToaster",
          _vm._b(
            {
              attrs: { isVisible: _vm.isToasterVisible },
              on: { close: _vm.closeToaster }
            },
            "KToaster",
            this.toaster,
            false
          )
        )
      ],
      1
    )
  ])
}
var staticRenderFns = []
render._withStripped = true

if (false) {
  module.hot.accept()
  if (module.hot.data) {
    require("vue-hot-reload-api")      .rerender("data-v-0009d6b6", { render: render, staticRenderFns: staticRenderFns })
  }
}

/***/ }),

/***/ 1861:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_DevRequestsChart_vue__ = __webpack_require__(754);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_DevRequestsChart_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_DevRequestsChart_vue__);
/* harmony namespace reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_DevRequestsChart_vue__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_DevRequestsChart_vue__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_8fc75114_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_DevRequestsChart_vue__ = __webpack_require__(1971);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__ = __webpack_require__(31);
var disposed = false
function injectStyle (context) {
  if (disposed) return
  __webpack_require__(1862)
}
/* script */


/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = injectStyle
/* scopeId */
var __vue_scopeId__ = "data-v-8fc75114"
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null

var Component = Object(__WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__["a" /* default */])(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_DevRequestsChart_vue___default.a,
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_8fc75114_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_DevRequestsChart_vue__["a" /* render */],
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_8fc75114_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_DevRequestsChart_vue__["b" /* staticRenderFns */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src/js/dashboard/components/DevRequestsChart.vue"

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-8fc75114", Component.options)
  } else {
    hotAPI.reload("data-v-8fc75114", Component.options)
  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["default"] = (Component.exports);


/***/ }),

/***/ 1862:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(1863);
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var add = __webpack_require__(30).default
var update = add("115eed88", content, false, {});
// Hot Module Replacement
if(false) {
 // When the styles change, update the <style> tags
 if(!content.locals) {
   module.hot.accept("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-8fc75114\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./DevRequestsChart.vue", function() {
     var newContent = require("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-8fc75114\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./DevRequestsChart.vue");
     if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
     update(newContent);
   });
 }
 // When the module is disposed, remove the <style> tags
 module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 1863:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(27)(undefined);
// imports


// module
exports.push([module.i, "\n.dev-requests-chart[data-v-8fc75114] {\n  margin-bottom: 30px;\n}\n.dev-requests-chart .chart-wrapper[data-v-8fc75114] {\n    position: relative;\n}\n.dev-requests-chart .chart-header[data-v-8fc75114] {\n    display: flex;\n    align-items: center;\n    margin-bottom: 1rem;\n}\n.dev-requests-chart .chart-header .right-content[data-v-8fc75114] {\n      display: flex;\n      align-items: center;\n      margin-left: auto;\n}\n.dev-requests-chart .chart-header .right-content .total-requests[data-v-8fc75114] {\n        padding-top: 1px;\n        font-size: 1rem;\n        margin-right: 10px;\n}\n", ""]);

// exports


/***/ }),

/***/ 1864:
/***/ (function(module, exports, __webpack_require__) {

var map = {
	"./af": 756,
	"./af.js": 756,
	"./ar": 757,
	"./ar-dz": 758,
	"./ar-dz.js": 758,
	"./ar-kw": 759,
	"./ar-kw.js": 759,
	"./ar-ly": 760,
	"./ar-ly.js": 760,
	"./ar-ma": 761,
	"./ar-ma.js": 761,
	"./ar-sa": 762,
	"./ar-sa.js": 762,
	"./ar-tn": 763,
	"./ar-tn.js": 763,
	"./ar.js": 757,
	"./az": 764,
	"./az.js": 764,
	"./be": 765,
	"./be.js": 765,
	"./bg": 766,
	"./bg.js": 766,
	"./bm": 767,
	"./bm.js": 767,
	"./bn": 768,
	"./bn.js": 768,
	"./bo": 769,
	"./bo.js": 769,
	"./br": 770,
	"./br.js": 770,
	"./bs": 771,
	"./bs.js": 771,
	"./ca": 772,
	"./ca.js": 772,
	"./cs": 773,
	"./cs.js": 773,
	"./cv": 774,
	"./cv.js": 774,
	"./cy": 775,
	"./cy.js": 775,
	"./da": 776,
	"./da.js": 776,
	"./de": 777,
	"./de-at": 778,
	"./de-at.js": 778,
	"./de-ch": 779,
	"./de-ch.js": 779,
	"./de.js": 777,
	"./dv": 780,
	"./dv.js": 780,
	"./el": 781,
	"./el.js": 781,
	"./en-au": 782,
	"./en-au.js": 782,
	"./en-ca": 783,
	"./en-ca.js": 783,
	"./en-gb": 784,
	"./en-gb.js": 784,
	"./en-ie": 785,
	"./en-ie.js": 785,
	"./en-nz": 786,
	"./en-nz.js": 786,
	"./eo": 787,
	"./eo.js": 787,
	"./es": 788,
	"./es-do": 789,
	"./es-do.js": 789,
	"./es-us": 790,
	"./es-us.js": 790,
	"./es.js": 788,
	"./et": 791,
	"./et.js": 791,
	"./eu": 792,
	"./eu.js": 792,
	"./fa": 793,
	"./fa.js": 793,
	"./fi": 794,
	"./fi.js": 794,
	"./fo": 795,
	"./fo.js": 795,
	"./fr": 796,
	"./fr-ca": 797,
	"./fr-ca.js": 797,
	"./fr-ch": 798,
	"./fr-ch.js": 798,
	"./fr.js": 796,
	"./fy": 799,
	"./fy.js": 799,
	"./gd": 800,
	"./gd.js": 800,
	"./gl": 801,
	"./gl.js": 801,
	"./gom-latn": 802,
	"./gom-latn.js": 802,
	"./gu": 803,
	"./gu.js": 803,
	"./he": 804,
	"./he.js": 804,
	"./hi": 805,
	"./hi.js": 805,
	"./hr": 806,
	"./hr.js": 806,
	"./hu": 807,
	"./hu.js": 807,
	"./hy-am": 808,
	"./hy-am.js": 808,
	"./id": 809,
	"./id.js": 809,
	"./is": 810,
	"./is.js": 810,
	"./it": 811,
	"./it.js": 811,
	"./ja": 812,
	"./ja.js": 812,
	"./jv": 813,
	"./jv.js": 813,
	"./ka": 814,
	"./ka.js": 814,
	"./kk": 815,
	"./kk.js": 815,
	"./km": 816,
	"./km.js": 816,
	"./kn": 817,
	"./kn.js": 817,
	"./ko": 818,
	"./ko.js": 818,
	"./ky": 819,
	"./ky.js": 819,
	"./lb": 820,
	"./lb.js": 820,
	"./lo": 821,
	"./lo.js": 821,
	"./lt": 822,
	"./lt.js": 822,
	"./lv": 823,
	"./lv.js": 823,
	"./me": 824,
	"./me.js": 824,
	"./mi": 825,
	"./mi.js": 825,
	"./mk": 826,
	"./mk.js": 826,
	"./ml": 827,
	"./ml.js": 827,
	"./mr": 828,
	"./mr.js": 828,
	"./ms": 829,
	"./ms-my": 830,
	"./ms-my.js": 830,
	"./ms.js": 829,
	"./mt": 831,
	"./mt.js": 831,
	"./my": 832,
	"./my.js": 832,
	"./nb": 833,
	"./nb.js": 833,
	"./ne": 834,
	"./ne.js": 834,
	"./nl": 835,
	"./nl-be": 836,
	"./nl-be.js": 836,
	"./nl.js": 835,
	"./nn": 837,
	"./nn.js": 837,
	"./pa-in": 838,
	"./pa-in.js": 838,
	"./pl": 839,
	"./pl.js": 839,
	"./pt": 840,
	"./pt-br": 841,
	"./pt-br.js": 841,
	"./pt.js": 840,
	"./ro": 842,
	"./ro.js": 842,
	"./ru": 843,
	"./ru.js": 843,
	"./sd": 844,
	"./sd.js": 844,
	"./se": 845,
	"./se.js": 845,
	"./si": 846,
	"./si.js": 846,
	"./sk": 847,
	"./sk.js": 847,
	"./sl": 848,
	"./sl.js": 848,
	"./sq": 849,
	"./sq.js": 849,
	"./sr": 850,
	"./sr-cyrl": 851,
	"./sr-cyrl.js": 851,
	"./sr.js": 850,
	"./ss": 852,
	"./ss.js": 852,
	"./sv": 853,
	"./sv.js": 853,
	"./sw": 854,
	"./sw.js": 854,
	"./ta": 855,
	"./ta.js": 855,
	"./te": 856,
	"./te.js": 856,
	"./tet": 857,
	"./tet.js": 857,
	"./th": 858,
	"./th.js": 858,
	"./tl-ph": 859,
	"./tl-ph.js": 859,
	"./tlh": 860,
	"./tlh.js": 860,
	"./tr": 861,
	"./tr.js": 861,
	"./tzl": 862,
	"./tzl.js": 862,
	"./tzm": 863,
	"./tzm-latn": 864,
	"./tzm-latn.js": 864,
	"./tzm.js": 863,
	"./uk": 865,
	"./uk.js": 865,
	"./ur": 866,
	"./ur.js": 866,
	"./uz": 867,
	"./uz-latn": 868,
	"./uz-latn.js": 868,
	"./uz.js": 867,
	"./vi": 869,
	"./vi.js": 869,
	"./x-pseudo": 870,
	"./x-pseudo.js": 870,
	"./yo": 871,
	"./yo.js": 871,
	"./zh-cn": 872,
	"./zh-cn.js": 872,
	"./zh-hk": 873,
	"./zh-hk.js": 873,
	"./zh-tw": 874,
	"./zh-tw.js": 874
};
function webpackContext(req) {
	return __webpack_require__(webpackContextResolve(req));
};
function webpackContextResolve(req) {
	var id = map[req];
	if(!(id + 1)) // check for number or string
		throw new Error("Cannot find module '" + req + "'.");
	return id;
};
webpackContext.keys = function webpackContextKeys() {
	return Object.keys(map);
};
webpackContext.resolve = webpackContextResolve;
module.exports = webpackContext;
webpackContext.id = 1864;

/***/ }),

/***/ 1865:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_LineChart_vue__ = __webpack_require__(875);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_LineChart_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_LineChart_vue__);
/* harmony namespace reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_LineChart_vue__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_LineChart_vue__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_runtime_component_normalizer__ = __webpack_require__(31);
var disposed = false
/* script */


/* template */
var __vue_render__, __vue_static_render_fns__
/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = null
/* scopeId */
var __vue_scopeId__ = null
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null

var Component = Object(__WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_runtime_component_normalizer__["a" /* default */])(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_LineChart_vue___default.a,
  __vue_render__,
  __vue_static_render_fns__,
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src/js/dashboard/components/LineChart.vue"

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-7e5ec5ee", Component.options)
  } else {
    hotAPI.reload("data-v-7e5ec5ee", Component.options)
  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["default"] = (Component.exports);


/***/ }),

/***/ 1962:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ChartControls_vue__ = __webpack_require__(898);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ChartControls_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ChartControls_vue__);
/* harmony namespace reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ChartControls_vue__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ChartControls_vue__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_b9d5be1a_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_ChartControls_vue__ = __webpack_require__(1965);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__ = __webpack_require__(31);
var disposed = false
function injectStyle (context) {
  if (disposed) return
  __webpack_require__(1963)
}
/* script */


/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = injectStyle
/* scopeId */
var __vue_scopeId__ = "data-v-b9d5be1a"
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null

var Component = Object(__WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__["a" /* default */])(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ChartControls_vue___default.a,
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_b9d5be1a_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_ChartControls_vue__["a" /* render */],
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_b9d5be1a_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_ChartControls_vue__["b" /* staticRenderFns */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src/js/dashboard/components/ChartControls.vue"

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-b9d5be1a", Component.options)
  } else {
    hotAPI.reload("data-v-b9d5be1a", Component.options)
  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["default"] = (Component.exports);


/***/ }),

/***/ 1963:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(1964);
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var add = __webpack_require__(30).default
var update = add("3e8f2ea4", content, false, {});
// Hot Module Replacement
if(false) {
 // When the styles change, update the <style> tags
 if(!content.locals) {
   module.hot.accept("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-b9d5be1a\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./ChartControls.vue", function() {
     var newContent = require("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-b9d5be1a\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./ChartControls.vue");
     if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
     update(newContent);
   });
 }
 // When the module is disposed, remove the <style> tags
 module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 1964:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(27)(undefined);
// imports


// module
exports.push([module.i, "\n.chart-controls[data-v-b9d5be1a] {\n  display: flex;\n  align-items: center;\n}\n.chart-controls select[data-v-b9d5be1a] {\n    margin-right: 12px;\n    background-color: #f5f5f5;\n    color: rgba(0, 0, 0, 0.7);\n    border-color: rgba(0, 0, 0, 0.12);\n    height: 42px;\n    width: 175px;\n    cursor: pointer;\n    font-size: 1rem;\n}\n.chart-controls #utc-button[data-v-b9d5be1a] {\n    display: flex;\n    align-items: center;\n    cursor: pointer;\n}\n.chart-controls #utc-button #checkbox[data-v-b9d5be1a] {\n      font-size: 1.4rem;\n      margin-right: 7px;\n}\n", ""]);

// exports


/***/ }),

/***/ 1965:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return render; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return staticRenderFns; });
var render = function() {
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c(
    "div",
    { staticClass: "chart-controls" },
    [
      _c(
        "select",
        {
          directives: [
            {
              name: "model",
              rawName: "v-model",
              value: _vm.localTimeFrame,
              expression: "localTimeFrame"
            }
          ],
          on: {
            change: [
              function($event) {
                var $$selectedVal = Array.prototype.filter
                  .call($event.target.options, function(o) {
                    return o.selected
                  })
                  .map(function(o) {
                    var val = "_value" in o ? o._value : o.value
                    return val
                  })
                _vm.localTimeFrame = $event.target.multiple
                  ? $$selectedVal
                  : $$selectedVal[0]
              },
              function($event) {
                _vm.onChange("timeFrame", _vm.localTimeFrame)
              }
            ]
          }
        },
        _vm._l(_vm.timeFrames, function(timeFrame) {
          return _c(
            "option",
            { key: timeFrame.text, domProps: { value: timeFrame.value } },
            [_vm._v("\n      " + _vm._s(timeFrame.text) + "\n    ")]
          )
        })
      ),
      _vm._v(" "),
      _c(
        "KButton",
        {
          attrs: {
            id: "utc-button",
            appearance: "secondary",
            "is-rounded": "",
            handleClick: _vm.toggleUtc
          }
        },
        [
          _c("input", {
            attrs: { type: "checkbox", id: "checkbox" },
            domProps: { checked: _vm.isUtc }
          }),
          _vm._v(" "),
          _c("div", [_vm._v("UTC")])
        ]
      )
    ],
    1
  )
}
var staticRenderFns = []
render._withStripped = true

if (false) {
  module.hot.accept()
  if (module.hot.data) {
    require("vue-hot-reload-api")      .rerender("data-v-b9d5be1a", { render: render, staticRenderFns: staticRenderFns })
  }
}

/***/ }),

/***/ 1966:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ChartTooltip_vue__ = __webpack_require__(899);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ChartTooltip_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ChartTooltip_vue__);
/* harmony namespace reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ChartTooltip_vue__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ChartTooltip_vue__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_08b1edd6_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_ChartTooltip_vue__ = __webpack_require__(1969);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__ = __webpack_require__(31);
var disposed = false
function injectStyle (context) {
  if (disposed) return
  __webpack_require__(1967)
}
/* script */


/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = injectStyle
/* scopeId */
var __vue_scopeId__ = "data-v-08b1edd6"
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null

var Component = Object(__WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__["a" /* default */])(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ChartTooltip_vue___default.a,
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_08b1edd6_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_ChartTooltip_vue__["a" /* render */],
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_08b1edd6_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_ChartTooltip_vue__["b" /* staticRenderFns */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src/js/dashboard/components/ChartTooltip.vue"

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-08b1edd6", Component.options)
  } else {
    hotAPI.reload("data-v-08b1edd6", Component.options)
  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["default"] = (Component.exports);


/***/ }),

/***/ 1967:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(1968);
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var add = __webpack_require__(30).default
var update = add("74196263", content, false, {});
// Hot Module Replacement
if(false) {
 // When the styles change, update the <style> tags
 if(!content.locals) {
   module.hot.accept("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-08b1edd6\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./ChartTooltip.vue", function() {
     var newContent = require("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-08b1edd6\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./ChartTooltip.vue");
     if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
     update(newContent);
   });
 }
 // When the module is disposed, remove the <style> tags
 module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 1968:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(27)(undefined);
// imports


// module
exports.push([module.i, "\n.chart-tooltip[data-v-08b1edd6] {\n  position: absolute;\n  font-size: 12px;\n  background-color: #FFF;\n  box-shadow: 0 1px 3px rgba(0, 0, 0, 0.12), 0 1px 2px rgba(0, 0, 0, 0.24);\n  transition: all 0.3s cubic-bezier(0.25, 0.8, 0.25, 1);\n  border-radius: 2px;\n  z-index: 1;\n  padding: 8px 10px 5px;\n  list-style: none;\n}\n.chart-tooltip li[data-v-08b1edd6] {\n    margin-bottom: 3px;\n    display: flex;\n    align-items: center;\n}\n.chart-tooltip li .display-time[data-v-08b1edd6] {\n      color: #808080;\n}\n", ""]);

// exports


/***/ }),

/***/ 1969:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return render; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return staticRenderFns; });
var render = function() {
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c(
    "ul",
    {
      directives: [
        {
          name: "show",
          rawName: "v-show",
          value: _vm.showTooltip,
          expression: "showTooltip"
        }
      ],
      ref: "tooltip",
      staticClass: "chart-tooltip",
      style: _vm.tooltipStyle
    },
    [
      _c("li", [
        _c("div", { staticClass: "display-time" }, [
          _vm._v(_vm._s(_vm.displayTime))
        ])
      ]),
      _vm._v(" "),
      _vm._l(_vm.tooltipBody, function(item, index) {
        return _c(
          "li",
          { key: index },
          _vm._l(item.lines, function(line) {
            return _c("div", { key: line }, [
              _vm._v("\n      " + _vm._s(line) + "\n    ")
            ])
          })
        )
      })
    ],
    2
  )
}
var staticRenderFns = []
render._withStripped = true

if (false) {
  module.hot.accept()
  if (module.hot.data) {
    require("vue-hot-reload-api")      .rerender("data-v-08b1edd6", { render: render, staticRenderFns: staticRenderFns })
  }
}

/***/ }),

/***/ 1970:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = {
  data: function data() {
    return {
      killPolling: null,
      pollWhenHidden: false
    };
  },
  beforeDestroy: function beforeDestroy() {
    this.teardownPolling();
  },


  methods: {
    setPolling: function setPolling(callback, interval) {
      var _this = this;

      this.teardownPolling();

      if (!this.pollWhenHidden && document.visibilityState === 'hidden') {
        this.killPolling = setTimeout(function () {
          _this.setPolling(callback, interval);
        }, interval);
        return;
      }

      this.killPolling = setTimeout(callback, interval);
    },
    teardownPolling: function teardownPolling() {
      clearTimeout(this.killPolling);
      this.killPolling = null;
    }
  }
};

/***/ }),

/***/ 1971:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return render; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return staticRenderFns; });
var render = function() {
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c(
    "div",
    {
      directives: [
        {
          name: "show",
          rawName: "v-show",
          value: _vm.vitalsEnabled,
          expression: "vitalsEnabled"
        }
      ],
      staticClass: "dev-requests-chart"
    },
    [
      _c(
        "div",
        { staticClass: "chart-header" },
        [
          _vm._t("header-content-left", [_c("h2", [_vm._v("Usage")])]),
          _vm._v(" "),
          _vm._t("header-content-right", [
            _c(
              "div",
              { staticClass: "right-content" },
              [
                _c("div", { staticClass: "total-requests" }, [
                  _vm._v(
                    "\n          " +
                      _vm._s(_vm.totalRequests) +
                      " " +
                      _vm._s(_vm.requestsText) +
                      " in the\n        "
                  )
                ]),
                _vm._v(" "),
                _c("ChartControls", {
                  attrs: {
                    "is-utc": _vm.isUtc,
                    "time-frame": _vm.timeFrame,
                    "on-change": _vm.handleControlChange
                  }
                })
              ],
              1
            )
          ])
        ],
        2
      ),
      _vm._v(" "),
      _c(
        "div",
        { staticClass: "chart-wrapper" },
        [
          _c("LineChart", {
            attrs: {
              options: _vm.options,
              height: _vm.height,
              "is-utc": _vm.isUtc,
              "chart-data": _vm.chartData
            }
          }),
          _vm._v(" "),
          _c("ChartTooltip", { attrs: { "tooltip-config": _vm.tooltipConfig } })
        ],
        1
      ),
      _vm._v(" "),
      _c(
        "KToaster",
        _vm._b(
          {
            attrs: { isVisible: _vm.isToasterVisible },
            on: { close: _vm.closeToaster }
          },
          "KToaster",
          this.toaster,
          false
        )
      )
    ],
    1
  )
}
var staticRenderFns = []
render._withStripped = true

if (false) {
  module.hot.accept()
  if (module.hot.data) {
    require("vue-hot-reload-api")      .rerender("data-v-8fc75114", { render: render, staticRenderFns: staticRenderFns })
  }
}

/***/ }),

/***/ 1972:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(46);

var _extends3 = _interopRequireDefault(_extends2);

var _BasicAuth = __webpack_require__(900);

var _BasicAuth2 = _interopRequireDefault(_BasicAuth);

var _KeyAuth = __webpack_require__(901);

var _KeyAuth2 = _interopRequireDefault(_KeyAuth);

var _OAuth = __webpack_require__(902);

var _OAuth2 = _interopRequireDefault(_OAuth);

var _HMAC = __webpack_require__(903);

var _HMAC2 = _interopRequireDefault(_HMAC);

var _JWT = __webpack_require__(904);

var _JWT2 = _interopRequireDefault(_JWT);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  'basic-auth': {
    title: 'Basic Authentication',
    plugin: 'basic-auth',
    schema: __webpack_require__(900),
    name: 'Basic Auth Credential',
    endpoint: '/basic-auth',
    fields: (0, _extends3.default)({}, _BasicAuth2.default)
  },
  'key-auth': {
    title: 'Key Authentication',
    plugin: 'key-auth',
    schema: __webpack_require__(901),
    name: 'Key Auth Credential',
    endpoint: '/key-auth',
    fields: (0, _extends3.default)({}, _KeyAuth2.default)
  },
  'oauth2': {
    title: 'OAuth 2.0',
    plugin: 'oauth2',
    schema: __webpack_require__(902),
    name: 'OAuth 2.0 Application',
    endpoint: '/oauth2',
    fields: (0, _extends3.default)({}, _OAuth2.default)
  },
  'hmac-auth': {
    title: 'HMAC Signature Authentication',
    plugin: 'hmac-auth',
    schema: __webpack_require__(903),
    name: 'HMAC Credential',
    endpoint: '/hmac-auth',
    fields: (0, _extends3.default)({}, _HMAC2.default)
  },
  'jwt': {
    title: 'JWT',
    plugin: 'jwt',
    schema: __webpack_require__(904),
    name: 'JWT Credential',
    endpoint: '/jwt',
    fields: (0, _extends3.default)({}, _JWT2.default)
  }
};

/***/ }),

/***/ 1973:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return render; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return staticRenderFns; });
var render = function() {
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c(
    "div",
    { staticClass: "dashboard" },
    [
      _c("h1", [_vm._v("Dashboard")]),
      _vm._v(" "),
      _c("DevRequestsChart", { attrs: { "axios-config": _vm.axiosConfig } }),
      _vm._v(" "),
      _c(
        "div",
        { staticClass: "table-header" },
        [
          _c("h2", [_vm._v(_vm._s(_vm.title))]),
          _vm._v(" "),
          !_vm.showEmpty
            ? _c(
                "KButton",
                {
                  attrs: {
                    id: "create-credential-button",
                    appearance: "secondary",
                    handleClick: _vm.openShowModal
                  }
                },
                [
                  _c("span", [_vm._v("+")]),
                  _vm._v(" Create API Credential\n    ")
                ]
              )
            : _vm._e()
        ],
        1
      ),
      _vm._v(" "),
      _vm._l(_vm.credentials, function(credential) {
        return !_vm.showEmpty
          ? _c("CredentialTable", {
              key: credential.plugin,
              ref: credential.plugin,
              refInFor: true,
              attrs: { id: credential.plugin, credentialOptions: credential }
            })
          : _vm._e()
      }),
      _vm._v(" "),
      _vm.showEmpty
        ? _c("div", { staticClass: "empty-credentials-wrapper" }, [
            _c("h3", [_vm._v("No credentials available.")]),
            _vm._v(" "),
            _c("p", [
              _vm._v(
                "The Dev Portal Admin has not yet enabled credentials. Please check back later."
              )
            ])
          ])
        : _vm._e(),
      _vm._v(" "),
      _vm.openModal !== null
        ? _c("CredentialFormModal", {
            attrs: {
              plugins: _vm.credentials,
              actionType: "create",
              submitModalCallback: _vm.createCredential,
              isVisible: _vm.openModal === "create"
            },
            on: { close: _vm.closeModal }
          })
        : _vm._e(),
      _vm._v(" "),
      _c(
        "KToaster",
        _vm._b(
          {
            attrs: { isVisible: _vm.isToasterVisible },
            on: { close: this.closeToaster }
          },
          "KToaster",
          this.toaster,
          false
        )
      )
    ],
    2
  )
}
var staticRenderFns = []
render._withStripped = true

if (false) {
  module.hot.accept()
  if (module.hot.data) {
    require("vue-hot-reload-api")      .rerender("data-v-0ac8e981", { render: render, staticRenderFns: staticRenderFns })
  }
}

/***/ }),

/***/ 1974:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_Settings_vue__ = __webpack_require__(905);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_Settings_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_Settings_vue__);
/* harmony namespace reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_Settings_vue__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_Settings_vue__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_d5d15f74_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_Settings_vue__ = __webpack_require__(1980);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__ = __webpack_require__(31);
var disposed = false
function injectStyle (context) {
  if (disposed) return
  __webpack_require__(1975)
  __webpack_require__(1977)
}
/* script */


/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = injectStyle
/* scopeId */
var __vue_scopeId__ = "data-v-d5d15f74"
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null

var Component = Object(__WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__["a" /* default */])(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_Settings_vue___default.a,
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_d5d15f74_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_Settings_vue__["a" /* render */],
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_d5d15f74_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_Settings_vue__["b" /* staticRenderFns */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src/js/dashboard/pages/Settings.vue"

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-d5d15f74", Component.options)
  } else {
    hotAPI.reload("data-v-d5d15f74", Component.options)
  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["default"] = (Component.exports);


/***/ }),

/***/ 1975:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(1976);
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var add = __webpack_require__(30).default
var update = add("2605e2a0", content, false, {});
// Hot Module Replacement
if(false) {
 // When the styles change, update the <style> tags
 if(!content.locals) {
   module.hot.accept("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"scoped\":false,\"sourceMap\":false}!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./Settings.vue", function() {
     var newContent = require("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"scoped\":false,\"sourceMap\":false}!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./Settings.vue");
     if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
     update(newContent);
   });
 }
 // When the module is disposed, remove the <style> tags
 module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 1976:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(27)(undefined);
// imports


// module
exports.push([module.i, "\n.button.outline-primary:hover {\n  font-weight: 400;\n}\n", ""]);

// exports


/***/ }),

/***/ 1977:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(1978);
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var add = __webpack_require__(30).default
var update = add("313a5f12", content, false, {});
// Hot Module Replacement
if(false) {
 // When the styles change, update the <style> tags
 if(!content.locals) {
   module.hot.accept("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-d5d15f74\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=1!./Settings.vue", function() {
     var newContent = require("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-d5d15f74\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=1!./Settings.vue");
     if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
     update(newContent);
   });
 }
 // When the module is disposed, remove the <style> tags
 module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 1978:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(27)(undefined);
// imports


// module
exports.push([module.i, "\nh2[data-v-d5d15f74] {\n  margin-top: 72px;\n}\n.user-preferences[data-v-d5d15f74] {\n  width: 60%;\n  margin: 0 auto;\n  min-width: 350px;\n}\nbutton[data-v-d5d15f74]:disabled {\n  cursor: not-allowed;\n  opacity: .65;\n}\nform[data-v-d5d15f74] {\n  margin: 24px 0;\n}\n.divider[data-v-d5d15f74] {\n  width: 100%;\n  height: 1px;\n  background: rgba(0, 0, 0, 0.1);\n  margin: 24px 0;\n}\n.delete-account[data-v-d5d15f74] {\n  display: flex;\n  padding: 0 16px;\n  align-items: center;\n  width: 100%;\n  height: 42px;\n  background-color: rgba(194, 10, 10, 0.1);\n  color: #c20a0a;\n  margin: 48px 0;\n}\n.delete-account[data-v-d5d15f74]:hover {\n    background-color: rgba(194, 10, 10, 0.2);\n}\n.danger-icon[data-v-d5d15f74] {\n  margin-right: 8px;\n}\n", ""]);

// exports


/***/ }),

/***/ 1980:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return render; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return staticRenderFns; });
var render = function() {
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c(
    "div",
    { staticClass: "user-preferences" },
    [
      _c("h1", [_vm._v("Settings")]),
      _vm._v(" "),
      _c(
        "div",
        { staticClass: "user-information" },
        [
          _c("h2", [_vm._v("User Information")]),
          _vm._v(" "),
          _c("div", { staticClass: "divider" }),
          _vm._v(" "),
          _vm.renderForm
            ? _c("CredentialForm", {
                attrs: {
                  model: _vm.infoFormModel,
                  actionType: "simple",
                  schema: _vm.infoFormSchema,
                  triggerSubmit: _vm.triggerInfoFormSubmit,
                  onSubmit: _vm.updateUserInfo,
                  isDisabled: !_vm.isEditingInfoForm
                }
              })
            : _vm._e(),
          _vm._v(" "),
          !_vm.isEditingInfoForm && _vm.canEditCredential
            ? _c(
                "KButton",
                {
                  attrs: {
                    appearance: "outline-primary",
                    isRounded: true,
                    handleClick: _vm.toggleInfoFormEdit
                  }
                },
                [_vm._v("\n      Edit User Information\n    ")]
              )
            : _vm._e(),
          _vm._v(" "),
          _c(
            "div",
            { staticClass: "row" },
            [
              _vm.isEditingInfoForm && _vm.canEditCredential
                ? _c(
                    "KButton",
                    {
                      attrs: {
                        appearance: "primary",
                        disabled: !_vm.canUpdateInfo,
                        isRounded: true,
                        handleClick: _vm.submitInfoForm
                      }
                    },
                    [_vm._v("\n        Update User Information\n      ")]
                  )
                : _vm._e(),
              _vm._v(" "),
              _vm.isEditingInfoForm && _vm.canEditCredential
                ? _c(
                    "KButton",
                    {
                      attrs: {
                        appearance: "secondary",
                        isRounded: true,
                        handleClick: _vm.cancelUpdateInfo
                      }
                    },
                    [_vm._v("\n        Cancel\n      ")]
                  )
                : _vm._e()
            ],
            1
          )
        ],
        1
      ),
      _vm._v(" "),
      _vm.canEditCredential
        ? _c(
            "div",
            { staticClass: "change-password" },
            [
              _c("h2", [_vm._v("Change " + _vm._s(_vm.credentialType))]),
              _vm._v(" "),
              _c("div", { staticClass: "divider" }),
              _vm._v(" "),
              _vm.isEditingCredentialForm
                ? _c("CredentialForm", {
                    attrs: {
                      model: _vm.credentialFormModel,
                      actionType: "simple",
                      schema: _vm.credentialFormSchema,
                      triggerSubmit: _vm.triggerCredentialFormSubmit,
                      onSubmit: _vm.updateCredentialInfo
                    }
                  })
                : _vm._e(),
              _vm._v(" "),
              !_vm.isEditingCredentialForm
                ? _c(
                    "KButton",
                    {
                      attrs: {
                        appearance: "outline-primary",
                        isRounded: true,
                        handleClick: _vm.toggleCredentialFormEdit
                      }
                    },
                    [
                      _vm._v(
                        "\n      Change " +
                          _vm._s(_vm.credentialType) +
                          "\n    "
                      )
                    ]
                  )
                : _vm._e(),
              _vm._v(" "),
              _c(
                "div",
                { staticClass: "row" },
                [
                  _vm.isEditingCredentialForm
                    ? _c(
                        "KButton",
                        {
                          attrs: {
                            appearance: "primary",
                            isRounded: true,
                            handleClick: _vm.submitCredentialForm
                          }
                        },
                        [
                          _vm._v(
                            "\n        Change " +
                              _vm._s(_vm.credentialType) +
                              "\n      "
                          )
                        ]
                      )
                    : _vm._e(),
                  _vm._v(" "),
                  _vm.isEditingCredentialForm
                    ? _c(
                        "KButton",
                        {
                          attrs: {
                            appearance: "secondary",
                            isRounded: true,
                            handleClick: _vm.cancelUpdateCredential
                          }
                        },
                        [_vm._v("\n        Cancel\n      ")]
                      )
                    : _vm._e()
                ],
                1
              )
            ],
            1
          )
        : _vm._e(),
      _vm._v(" "),
      _c(
        "button",
        { staticClass: "delete-account", on: { click: _vm.toggleModal } },
        [
          _c(
            "svg",
            {
              staticClass: "danger-icon",
              attrs: {
                width: "16px",
                height: "16px",
                viewBox: "0 0 16 16",
                version: "1.1",
                xmlns: "http://www.w3.org/2000/svg",
                "xmlns:xlink": "http://www.w3.org/1999/xlink"
              }
            },
            [
              _c(
                "g",
                {
                  attrs: {
                    id: "Page-1",
                    stroke: "none",
                    "stroke-width": "1",
                    fill: "none",
                    "fill-rule": "evenodd"
                  }
                },
                [
                  _c(
                    "g",
                    {
                      attrs: {
                        id:
                          "03-01-update-user-settings--settings-page-blocked-inputs",
                        transform: "translate(-464.000000, -760.000000)",
                        fill: "#E65050"
                      }
                    },
                    [
                      _c(
                        "g",
                        {
                          attrs: {
                            id: "section--delete-account",
                            transform: "translate(448.000000, 743.000000)"
                          }
                        },
                        [
                          _c("path", {
                            attrs: {
                              d:
                                "M24,33 C19.581722,33 16,29.418278 16,25 C16,20.581722 19.581722,17 24,17 C28.418278,17 32,20.581722 32,25 C32,29.418278 28.418278,33 24,33 Z M19.5,24 C19.2238576,24 19,24.2238576 19,24.5 L19,25.5 C19,25.7761424 19.2238576,26 19.5,26 L28.5,26 C28.7761424,26 29,25.7761424 29,25.5 L29,24.5 C29,24.2238576 28.7761424,24 28.5,24 L19.5,24 Z",
                              id: "icn--delete"
                            }
                          })
                        ]
                      )
                    ]
                  )
                ]
              )
            ]
          ),
          _vm._v("\n    Delete Account\n  ")
        ]
      ),
      _vm._v(" "),
      _c(
        "KModal",
        { attrs: { isVisible: _vm.showModal }, on: { close: _vm.toggleModal } },
        [
          _c("template", { slot: "header-content" }, [
            _vm._v("Delete User Account")
          ]),
          _vm._v(" "),
          _c("template", { slot: "body-content" }, [
            _c("p", [_vm._v("Are you sure you want to delete your account")]),
            _vm._v(" "),
            _c("p", { staticClass: "light" }, [
              _vm._v(
                "After deletion you will not be able to recover your account or permissions."
              )
            ])
          ]),
          _vm._v(" "),
          _c(
            "template",
            { slot: "footer-actions" },
            [
              _c(
                "KButton",
                {
                  attrs: {
                    appearance: "danger",
                    handleClick: _vm.deleteUserAccount
                  }
                },
                [_vm._v("Delete User Account")]
              )
            ],
            1
          )
        ],
        2
      ),
      _vm._v(" "),
      _c(
        "KToaster",
        _vm._b(
          {
            attrs: { isVisible: _vm.isToasterVisible },
            on: { close: _vm.closeToaster }
          },
          "KToaster",
          this.toaster,
          false
        )
      )
    ],
    1
  )
}
var staticRenderFns = []
render._withStripped = true

if (false) {
  module.hot.accept()
  if (module.hot.data) {
    require("vue-hot-reload-api")      .rerender("data-v-d5d15f74", { render: render, staticRenderFns: staticRenderFns })
  }
}

/***/ }),

/***/ 1981:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ResetPassword_vue__ = __webpack_require__(906);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ResetPassword_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ResetPassword_vue__);
/* harmony namespace reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ResetPassword_vue__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ResetPassword_vue__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_2e121e77_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_ResetPassword_vue__ = __webpack_require__(1984);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__ = __webpack_require__(31);
var disposed = false
function injectStyle (context) {
  if (disposed) return
  __webpack_require__(1982)
}
/* script */


/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = injectStyle
/* scopeId */
var __vue_scopeId__ = "data-v-2e121e77"
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null

var Component = Object(__WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__["a" /* default */])(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ResetPassword_vue___default.a,
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_2e121e77_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_ResetPassword_vue__["a" /* render */],
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_2e121e77_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_ResetPassword_vue__["b" /* staticRenderFns */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src/js/dashboard/pages/ResetPassword.vue"

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-2e121e77", Component.options)
  } else {
    hotAPI.reload("data-v-2e121e77", Component.options)
  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["default"] = (Component.exports);


/***/ }),

/***/ 1982:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(1983);
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var add = __webpack_require__(30).default
var update = add("5b6596ba", content, false, {});
// Hot Module Replacement
if(false) {
 // When the styles change, update the <style> tags
 if(!content.locals) {
   module.hot.accept("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-2e121e77\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./ResetPassword.vue", function() {
     var newContent = require("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-2e121e77\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./ResetPassword.vue");
     if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
     update(newContent);
   });
 }
 // When the module is disposed, remove the <style> tags
 module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 1983:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(27)(undefined);
// imports


// module
exports.push([module.i, "\n.reset-password[data-v-2e121e77] {\n  margin: 120px auto;\n  max-width: 350px;\n  text-align: center;\n}\n.reset-password p[data-v-2e121e77] {\n    font-size: 16px;\n    color: rgba(0, 0, 0, 0.7);\n}\n.reset-password a[data-v-2e121e77] {\n    font-size: 14px;\n    color: rgba(0, 0, 0, 0.45);\n}\n.reset-password input[data-v-2e121e77] {\n    width: 100%;\n    height: 36px;\n    font-size: 14px;\n    color: #4D4D4D;\n}\n.reset-password button[data-v-2e121e77] {\n    padding: .5rem 1rem !important;\n    width: 100%;\n}\n.reset-password button[data-v-2e121e77]:disabled {\n      cursor: not-allowed;\n      opacity: .65;\n}\n.reset-password .form[data-v-2e121e77] {\n    margin: 24px 0;\n}\n.reset-password .form p[data-v-2e121e77] {\n      margin: 0;\n}\n.reset-password .form input[data-v-2e121e77] {\n      margin-bottom: 24px;\n}\n.reset-password .form .label[data-v-2e121e77] {\n      text-align: left;\n      padding-bottom: 8px;\n}\n", ""]);

// exports


/***/ }),

/***/ 1984:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return render; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return staticRenderFns; });
var render = function() {
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c(
    "div",
    { staticClass: "reset-password" },
    [
      _vm.hasToken
        ? [
            _vm.passwordChangeSuccess
              ? _c("div", [
                  _c("h1", [_vm._v("Success!")]),
                  _vm._v(" "),
                  _vm._m(0),
                  _vm._v(" "),
                  _c(
                    "a",
                    { attrs: { href: _vm.getWorkspacedPath("/login") } },
                    [
                      _c("KButton", { attrs: { appearance: "primary" } }, [
                        _vm._v("Go to Login")
                      ])
                    ],
                    1
                  )
                ])
              : _c("div", [
                  _c("h1", [_vm._v("Change Password")]),
                  _vm._v(" "),
                  _c(
                    "div",
                    { staticClass: "form" },
                    [
                      _c("p", { staticClass: "label" }, [
                        _vm._v(
                          "New " + _vm._s(_vm.capitalize(_vm.credentialType))
                        )
                      ]),
                      _vm._v(" "),
                      _vm.credentialType === "checkbox"
                        ? _c("input", {
                            directives: [
                              {
                                name: "model",
                                rawName: "v-model",
                                value: _vm.passwordModel.newPassword,
                                expression: "passwordModel.newPassword"
                              }
                            ],
                            attrs: { type: "checkbox" },
                            domProps: {
                              checked: Array.isArray(
                                _vm.passwordModel.newPassword
                              )
                                ? _vm._i(_vm.passwordModel.newPassword, null) >
                                  -1
                                : _vm.passwordModel.newPassword
                            },
                            on: {
                              change: function($event) {
                                var $$a = _vm.passwordModel.newPassword,
                                  $$el = $event.target,
                                  $$c = $$el.checked ? true : false
                                if (Array.isArray($$a)) {
                                  var $$v = null,
                                    $$i = _vm._i($$a, $$v)
                                  if ($$el.checked) {
                                    $$i < 0 &&
                                      _vm.$set(
                                        _vm.passwordModel,
                                        "newPassword",
                                        $$a.concat([$$v])
                                      )
                                  } else {
                                    $$i > -1 &&
                                      _vm.$set(
                                        _vm.passwordModel,
                                        "newPassword",
                                        $$a
                                          .slice(0, $$i)
                                          .concat($$a.slice($$i + 1))
                                      )
                                  }
                                } else {
                                  _vm.$set(
                                    _vm.passwordModel,
                                    "newPassword",
                                    $$c
                                  )
                                }
                              }
                            }
                          })
                        : _vm.credentialType === "radio"
                        ? _c("input", {
                            directives: [
                              {
                                name: "model",
                                rawName: "v-model",
                                value: _vm.passwordModel.newPassword,
                                expression: "passwordModel.newPassword"
                              }
                            ],
                            attrs: { type: "radio" },
                            domProps: {
                              checked: _vm._q(
                                _vm.passwordModel.newPassword,
                                null
                              )
                            },
                            on: {
                              change: function($event) {
                                _vm.$set(_vm.passwordModel, "newPassword", null)
                              }
                            }
                          })
                        : _c("input", {
                            directives: [
                              {
                                name: "model",
                                rawName: "v-model",
                                value: _vm.passwordModel.newPassword,
                                expression: "passwordModel.newPassword"
                              }
                            ],
                            attrs: { type: _vm.credentialType },
                            domProps: { value: _vm.passwordModel.newPassword },
                            on: {
                              input: function($event) {
                                if ($event.target.composing) {
                                  return
                                }
                                _vm.$set(
                                  _vm.passwordModel,
                                  "newPassword",
                                  $event.target.value
                                )
                              }
                            }
                          }),
                      _vm._v(" "),
                      _c("p", { staticClass: "label" }, [
                        _vm._v(
                          "Confirm New " +
                            _vm._s(_vm.capitalize(_vm.credentialType))
                        )
                      ]),
                      _vm._v(" "),
                      _vm.credentialType === "checkbox"
                        ? _c("input", {
                            directives: [
                              {
                                name: "model",
                                rawName: "v-model",
                                value: _vm.passwordModel.newPasswordConfirm,
                                expression: "passwordModel.newPasswordConfirm"
                              }
                            ],
                            attrs: { type: "checkbox" },
                            domProps: {
                              checked: Array.isArray(
                                _vm.passwordModel.newPasswordConfirm
                              )
                                ? _vm._i(
                                    _vm.passwordModel.newPasswordConfirm,
                                    null
                                  ) > -1
                                : _vm.passwordModel.newPasswordConfirm
                            },
                            on: {
                              change: function($event) {
                                var $$a = _vm.passwordModel.newPasswordConfirm,
                                  $$el = $event.target,
                                  $$c = $$el.checked ? true : false
                                if (Array.isArray($$a)) {
                                  var $$v = null,
                                    $$i = _vm._i($$a, $$v)
                                  if ($$el.checked) {
                                    $$i < 0 &&
                                      _vm.$set(
                                        _vm.passwordModel,
                                        "newPasswordConfirm",
                                        $$a.concat([$$v])
                                      )
                                  } else {
                                    $$i > -1 &&
                                      _vm.$set(
                                        _vm.passwordModel,
                                        "newPasswordConfirm",
                                        $$a
                                          .slice(0, $$i)
                                          .concat($$a.slice($$i + 1))
                                      )
                                  }
                                } else {
                                  _vm.$set(
                                    _vm.passwordModel,
                                    "newPasswordConfirm",
                                    $$c
                                  )
                                }
                              }
                            }
                          })
                        : _vm.credentialType === "radio"
                        ? _c("input", {
                            directives: [
                              {
                                name: "model",
                                rawName: "v-model",
                                value: _vm.passwordModel.newPasswordConfirm,
                                expression: "passwordModel.newPasswordConfirm"
                              }
                            ],
                            attrs: { type: "radio" },
                            domProps: {
                              checked: _vm._q(
                                _vm.passwordModel.newPasswordConfirm,
                                null
                              )
                            },
                            on: {
                              change: function($event) {
                                _vm.$set(
                                  _vm.passwordModel,
                                  "newPasswordConfirm",
                                  null
                                )
                              }
                            }
                          })
                        : _c("input", {
                            directives: [
                              {
                                name: "model",
                                rawName: "v-model",
                                value: _vm.passwordModel.newPasswordConfirm,
                                expression: "passwordModel.newPasswordConfirm"
                              }
                            ],
                            attrs: { type: _vm.credentialType },
                            domProps: {
                              value: _vm.passwordModel.newPasswordConfirm
                            },
                            on: {
                              input: function($event) {
                                if ($event.target.composing) {
                                  return
                                }
                                _vm.$set(
                                  _vm.passwordModel,
                                  "newPasswordConfirm",
                                  $event.target.value
                                )
                              }
                            }
                          }),
                      _vm._v(" "),
                      _c(
                        "KButton",
                        {
                          attrs: {
                            appearance: "primary",
                            disabled: !_vm.canSubmitPassword,
                            isRounded: true,
                            handleClick: _vm.resetPassword
                          }
                        },
                        [
                          _vm._v(
                            "\n          Change " +
                              _vm._s(_vm.capitalize(_vm.credentialType)) +
                              "\n        "
                          )
                        ]
                      )
                    ],
                    1
                  )
                ])
          ]
        : [
            _vm.emailSent
              ? _c("div", [
                  _c("h1", [_vm._v("Check your Email")]),
                  _vm._v(" "),
                  _c("div", { staticClass: "form" }, [
                    _c("p", [
                      _vm._v(
                        "We sent an email to " + _vm._s(_vm.userEmail) + "."
                      )
                    ])
                  ]),
                  _vm._v(" "),
                  _c(
                    "a",
                    { attrs: { href: _vm.getWorkspacedPath("/login") } },
                    [
                      _c("KButton", { attrs: { appearance: "primary" } }, [
                        _vm._v("Go to Login")
                      ])
                    ],
                    1
                  )
                ])
              : _c("div", [
                  _c("h1", [
                    _vm._v(
                      "Reset " + _vm._s(_vm.capitalize(_vm.credentialType))
                    )
                  ]),
                  _vm._v(" "),
                  _c("p", [
                    _vm._v(
                      "To reset your " +
                        _vm._s(_vm.credentialType) +
                        ", please enter the email you use to sign in to this Developer Portal."
                    )
                  ]),
                  _vm._v(" "),
                  _c(
                    "div",
                    { staticClass: "form" },
                    [
                      _c("input", {
                        directives: [
                          {
                            name: "model",
                            rawName: "v-model",
                            value: _vm.emailModel,
                            expression: "emailModel"
                          }
                        ],
                        attrs: { name: "email" },
                        domProps: { value: _vm.emailModel },
                        on: {
                          input: function($event) {
                            if ($event.target.composing) {
                              return
                            }
                            _vm.emailModel = $event.target.value
                          }
                        }
                      }),
                      _vm._v(" "),
                      _c(
                        "KButton",
                        {
                          attrs: {
                            disabled: !_vm.canSubmitEmail,
                            appearance: "primary",
                            handleClick: _vm.requestResetPassword
                          }
                        },
                        [
                          _vm._v(
                            "\n          Reset My " +
                              _vm._s(_vm.capitalize(_vm.credentialType)) +
                              "\n        "
                          )
                        ]
                      )
                    ],
                    1
                  ),
                  _vm._v(" "),
                  _c(
                    "a",
                    { attrs: { href: _vm.getWorkspacedPath("/login") } },
                    [_vm._v("‹ Go Back to Login")]
                  )
                ])
          ],
      _vm._v(" "),
      _c(
        "KToaster",
        _vm._b(
          {
            attrs: { isVisible: _vm.isToasterVisible },
            on: { close: _vm.closeToaster }
          },
          "KToaster",
          this.toaster,
          false
        )
      )
    ],
    2
  )
}
var staticRenderFns = [
  function() {
    var _vm = this
    var _h = _vm.$createElement
    var _c = _vm._self._c || _h
    return _c("div", { staticClass: "form" }, [
      _c("p", [_vm._v("Your password has been updated")])
    ])
  }
]
render._withStripped = true

if (false) {
  module.hot.accept()
  if (module.hot.data) {
    require("vue-hot-reload-api")      .rerender("data-v-2e121e77", { render: render, staticRenderFns: staticRenderFns })
  }
}

/***/ }),

/***/ 1985:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_VerifyAccount_vue__ = __webpack_require__(907);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_VerifyAccount_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_VerifyAccount_vue__);
/* harmony namespace reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_VerifyAccount_vue__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_VerifyAccount_vue__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_bcd7a83e_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_VerifyAccount_vue__ = __webpack_require__(1988);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__ = __webpack_require__(31);
var disposed = false
function injectStyle (context) {
  if (disposed) return
  __webpack_require__(1986)
}
/* script */


/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = injectStyle
/* scopeId */
var __vue_scopeId__ = "data-v-bcd7a83e"
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null

var Component = Object(__WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__["a" /* default */])(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_VerifyAccount_vue___default.a,
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_bcd7a83e_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_VerifyAccount_vue__["a" /* render */],
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_bcd7a83e_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_VerifyAccount_vue__["b" /* staticRenderFns */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src/js/dashboard/pages/VerifyAccount.vue"

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-bcd7a83e", Component.options)
  } else {
    hotAPI.reload("data-v-bcd7a83e", Component.options)
  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["default"] = (Component.exports);


/***/ }),

/***/ 1986:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(1987);
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var add = __webpack_require__(30).default
var update = add("ebfa5924", content, false, {});
// Hot Module Replacement
if(false) {
 // When the styles change, update the <style> tags
 if(!content.locals) {
   module.hot.accept("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-bcd7a83e\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./VerifyAccount.vue", function() {
     var newContent = require("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-bcd7a83e\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./VerifyAccount.vue");
     if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
     update(newContent);
   });
 }
 // When the module is disposed, remove the <style> tags
 module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 1987:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(27)(undefined);
// imports


// module
exports.push([module.i, "\n.verify-account[data-v-bcd7a83e] {\n  margin: 208px auto;\n}\n.verify-prompt[data-v-bcd7a83e], .account-verified[data-v-bcd7a83e] {\n  display: flex;\n  flex-direction: column;\n  text-align: center;\n}\n.verify-prompt .form[data-v-bcd7a83e], .account-verified .form[data-v-bcd7a83e] {\n    display: flex;\n    flex-direction: column;\n    margin: 24px 0;\n}\n.verify-prompt h1[data-v-bcd7a83e], .account-verified h1[data-v-bcd7a83e] {\n    margin: 0;\n}\n.verify-prompt button[data-v-bcd7a83e], .verify-prompt a[data-v-bcd7a83e], .account-verified button[data-v-bcd7a83e], .account-verified a[data-v-bcd7a83e] {\n    margin: 0 auto;\n}\n.verify-prompt button[data-v-bcd7a83e]:disabled, .account-verified button[data-v-bcd7a83e]:disabled {\n    opacity: 0.3;\n    cursor: not-allowed;\n}\n", ""]);

// exports


/***/ }),

/***/ 1988:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return render; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return staticRenderFns; });
var render = function() {
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c(
    "div",
    { staticClass: "verify-account" },
    [
      _vm.verifyAccountSuccess
        ? _c("div", { staticClass: "account-verified" }, [
            _vm.developerStatus === 0
              ? _c("div", [
                  _c("h1", [_vm._v("Account Verified")]),
                  _vm._v(" "),
                  _c("p", [_vm._v("Your account has been verified.")]),
                  _vm._v(" "),
                  _c(
                    "a",
                    { attrs: { href: _vm.getWorkspacedPath("/login") } },
                    [
                      _c("KButton", { attrs: { appearance: "primary" } }, [
                        _vm._v("\n          Go to Login\n        ")
                      ])
                    ],
                    1
                  )
                ])
              : _c("div", [
                  _c("h1", [_vm._v("Account Verified")]),
                  _vm._v(" "),
                  _c("p", [
                    _vm._v(
                      "Thank you for verifying your email.  Your account is pending approval.  We will email when your account is approved."
                    )
                  ]),
                  _vm._v(" "),
                  _c(
                    "a",
                    { attrs: { href: _vm.getWorkspacedPath("/") } },
                    [
                      _c("KButton", { attrs: { appearance: "primary" } }, [
                        _vm._v("\n          Back to Homepage\n        ")
                      ])
                    ],
                    1
                  )
                ])
          ])
        : _c("div", { staticClass: "verify-prompt" }, [
            _c("h1", [_vm._v("Account Verification")]),
            _vm._v(" "),
            _c("p", [
              _vm._v(
                "Click the button below to verify your account for " +
                  _vm._s(_vm.email) +
                  "."
              )
            ]),
            _vm._v(" "),
            _c(
              "div",
              { staticClass: "form" },
              [
                _c(
                  "KButton",
                  {
                    attrs: {
                      appearance: "primary",
                      disabled: _vm.isLoading,
                      isRounded: true,
                      handleClick: _vm.verifyAccount
                    }
                  },
                  [_vm._v("\n        Verify Account\n      ")]
                ),
                _vm._v(" "),
                _c(
                  "a",
                  {
                    attrs: {
                      href: _vm.getWorkspacedPath(
                        "/account/resend-verification"
                      )
                    }
                  },
                  [
                    _c("KButton", { attrs: { appearance: "btn-link" } }, [
                      _vm._v(
                        "\n          Resend Account Verification\n        "
                      )
                    ])
                  ],
                  1
                )
              ],
              1
            )
          ]),
      _vm._v(" "),
      _c(
        "KToaster",
        _vm._b(
          {
            attrs: { isVisible: _vm.isToasterVisible },
            on: { close: _vm.closeToaster }
          },
          "KToaster",
          this.toaster,
          false
        )
      )
    ],
    1
  )
}
var staticRenderFns = []
render._withStripped = true

if (false) {
  module.hot.accept()
  if (module.hot.data) {
    require("vue-hot-reload-api")      .rerender("data-v-bcd7a83e", { render: render, staticRenderFns: staticRenderFns })
  }
}

/***/ }),

/***/ 1989:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ResendAccountVerification_vue__ = __webpack_require__(908);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ResendAccountVerification_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ResendAccountVerification_vue__);
/* harmony namespace reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ResendAccountVerification_vue__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ResendAccountVerification_vue__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_357cfd1a_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_ResendAccountVerification_vue__ = __webpack_require__(1992);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__ = __webpack_require__(31);
var disposed = false
function injectStyle (context) {
  if (disposed) return
  __webpack_require__(1990)
}
/* script */


/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = injectStyle
/* scopeId */
var __vue_scopeId__ = "data-v-357cfd1a"
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null

var Component = Object(__WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__["a" /* default */])(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_ResendAccountVerification_vue___default.a,
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_357cfd1a_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_ResendAccountVerification_vue__["a" /* render */],
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_357cfd1a_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_ResendAccountVerification_vue__["b" /* staticRenderFns */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src/js/dashboard/pages/ResendAccountVerification.vue"

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-357cfd1a", Component.options)
  } else {
    hotAPI.reload("data-v-357cfd1a", Component.options)
  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["default"] = (Component.exports);


/***/ }),

/***/ 1990:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(1991);
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var add = __webpack_require__(30).default
var update = add("37bad34f", content, false, {});
// Hot Module Replacement
if(false) {
 // When the styles change, update the <style> tags
 if(!content.locals) {
   module.hot.accept("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-357cfd1a\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./ResendAccountVerification.vue", function() {
     var newContent = require("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-357cfd1a\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./ResendAccountVerification.vue");
     if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
     update(newContent);
   });
 }
 // When the module is disposed, remove the <style> tags
 module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 1991:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(27)(undefined);
// imports


// module
exports.push([module.i, "\n.resend-account-verification[data-v-357cfd1a] {\n  margin: 208px auto;\n}\n.resend-prompt[data-v-357cfd1a], .resend-success[data-v-357cfd1a] {\n  display: flex;\n  flex-direction: column;\n  text-align: center;\n}\n.resend-prompt .form[data-v-357cfd1a], .resend-success .form[data-v-357cfd1a] {\n    display: flex;\n    flex-direction: column;\n    margin: 24px 0;\n}\n.resend-prompt h1[data-v-357cfd1a], .resend-success h1[data-v-357cfd1a] {\n    margin: 0;\n}\n.resend-prompt input[data-v-357cfd1a], .resend-success input[data-v-357cfd1a] {\n    width: 256px;\n    margin: 0 auto 24px;\n}\n.resend-prompt button[data-v-357cfd1a], .resend-prompt a[data-v-357cfd1a], .resend-success button[data-v-357cfd1a], .resend-success a[data-v-357cfd1a] {\n    margin: 0 auto;\n}\n.resend-prompt button[data-v-357cfd1a]:disabled, .resend-success button[data-v-357cfd1a]:disabled {\n    opacity: 0.3;\n    cursor: not-allowed;\n}\n", ""]);

// exports


/***/ }),

/***/ 1992:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return render; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return staticRenderFns; });
var render = function() {
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c(
    "div",
    { staticClass: "resend-account-verification" },
    [
      !_vm.isSuccessfull
        ? _c("div", { staticClass: "resend-prompt" }, [
            _c("h1", [_vm._v("Resend Verification:")]),
            _vm._v(" "),
            _c("p", [_vm._v("Enter email to resend account verification")]),
            _vm._v(" "),
            _c(
              "div",
              { staticClass: "form" },
              [
                _c("input", {
                  directives: [
                    {
                      name: "model",
                      rawName: "v-model",
                      value: _vm.email,
                      expression: "email"
                    }
                  ],
                  domProps: { value: _vm.email },
                  on: {
                    input: function($event) {
                      if ($event.target.composing) {
                        return
                      }
                      _vm.email = $event.target.value
                    }
                  }
                }),
                _vm._v(" "),
                _c(
                  "KButton",
                  {
                    attrs: {
                      appearance: "primary",
                      disabled: _vm.isLoading,
                      isRounded: true,
                      handleClick: _vm.resendAccountVerification
                    }
                  },
                  [_vm._v("\n        Resend Verification\n      ")]
                )
              ],
              1
            )
          ])
        : _c("div", { staticClass: "resend-success" }, [
            _c("h1", [_vm._v("Success")]),
            _vm._v(" "),
            _c("p", [
              _vm._v(
                "If you have an account with us, you should recieve an email shortly."
              )
            ])
          ]),
      _vm._v(" "),
      _c(
        "KToaster",
        _vm._b(
          {
            attrs: { isVisible: _vm.isToasterVisible },
            on: { close: _vm.closeToaster }
          },
          "KToaster",
          this.toaster,
          false
        )
      )
    ],
    1
  )
}
var staticRenderFns = []
render._withStripped = true

if (false) {
  module.hot.accept()
  if (module.hot.data) {
    require("vue-hot-reload-api")      .rerender("data-v-357cfd1a", { render: render, staticRenderFns: staticRenderFns })
  }
}

/***/ }),

/***/ 1993:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_InvalidateAccountVerification_vue__ = __webpack_require__(909);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_InvalidateAccountVerification_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_InvalidateAccountVerification_vue__);
/* harmony namespace reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_InvalidateAccountVerification_vue__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_InvalidateAccountVerification_vue__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_67e8859a_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_InvalidateAccountVerification_vue__ = __webpack_require__(1996);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__ = __webpack_require__(31);
var disposed = false
function injectStyle (context) {
  if (disposed) return
  __webpack_require__(1994)
}
/* script */


/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = injectStyle
/* scopeId */
var __vue_scopeId__ = "data-v-67e8859a"
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null

var Component = Object(__WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__["a" /* default */])(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_InvalidateAccountVerification_vue___default.a,
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_67e8859a_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_InvalidateAccountVerification_vue__["a" /* render */],
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_67e8859a_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_InvalidateAccountVerification_vue__["b" /* staticRenderFns */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src/js/dashboard/pages/InvalidateAccountVerification.vue"

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-67e8859a", Component.options)
  } else {
    hotAPI.reload("data-v-67e8859a", Component.options)
  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["default"] = (Component.exports);


/***/ }),

/***/ 1994:
/***/ (function(module, exports, __webpack_require__) {

// style-loader: Adds some css to the DOM by adding a <style> tag

// load the styles
var content = __webpack_require__(1995);
if(typeof content === 'string') content = [[module.i, content, '']];
if(content.locals) module.exports = content.locals;
// add the styles to the DOM
var add = __webpack_require__(30).default
var update = add("1106cef2", content, false, {});
// Hot Module Replacement
if(false) {
 // When the styles change, update the <style> tags
 if(!content.locals) {
   module.hot.accept("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-67e8859a\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./InvalidateAccountVerification.vue", function() {
     var newContent = require("!!../../../../node_modules/css-loader/index.js!../../../../node_modules/vue-loader/lib/style-compiler/index.js?{\"optionsId\":\"0\",\"vue\":true,\"id\":\"data-v-67e8859a\",\"scoped\":true,\"sourceMap\":false}!../../../../node_modules/sass-loader/lib/loader.js!../../../../node_modules/vue-loader/lib/selector.js?type=styles&index=0!./InvalidateAccountVerification.vue");
     if(typeof newContent === 'string') newContent = [[module.id, newContent, '']];
     update(newContent);
   });
 }
 // When the module is disposed, remove the <style> tags
 module.hot.dispose(function() { update(); });
}

/***/ }),

/***/ 1995:
/***/ (function(module, exports, __webpack_require__) {

exports = module.exports = __webpack_require__(27)(undefined);
// imports


// module
exports.push([module.i, "\n.invalidate-account-verification[data-v-67e8859a] {\n  margin: 208px auto;\n}\n.invalidate-prompt[data-v-67e8859a], .invalidate-success[data-v-67e8859a] {\n  display: flex;\n  flex-direction: column;\n  text-align: center;\n}\n.invalidate-prompt .form[data-v-67e8859a], .invalidate-success .form[data-v-67e8859a] {\n    display: flex;\n    flex-direction: column;\n    margin: 24px 0;\n}\n.invalidate-prompt h1[data-v-67e8859a], .invalidate-success h1[data-v-67e8859a] {\n    margin: 0;\n}\n.invalidate-prompt input[data-v-67e8859a], .invalidate-success input[data-v-67e8859a] {\n    width: 256px;\n    margin: 0 auto 24px;\n}\n.invalidate-prompt button[data-v-67e8859a], .invalidate-prompt a[data-v-67e8859a], .invalidate-success button[data-v-67e8859a], .invalidate-success a[data-v-67e8859a] {\n    margin: 0 auto;\n}\n.invalidate-prompt button[data-v-67e8859a]:disabled, .invalidate-success button[data-v-67e8859a]:disabled {\n    opacity: 0.3;\n    cursor: not-allowed;\n}\n", ""]);

// exports


/***/ }),

/***/ 1996:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return render; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return staticRenderFns; });
var render = function() {
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c(
    "div",
    { staticClass: "invalidate-account-verification" },
    [
      !_vm.isSuccessfull
        ? _c("div", { staticClass: "invalidate-prompt" }, [
            _c("h1", [_vm._v("Invalidate Verification Token")]),
            _vm._v(" "),
            _c("p", [
              _vm._v(
                "Click below to invalidate validation request for " +
                  _vm._s(_vm.email) +
                  "."
              )
            ]),
            _vm._v(" "),
            _c(
              "div",
              { staticClass: "form" },
              [
                _c(
                  "KButton",
                  {
                    attrs: {
                      appearance: "primary",
                      disabled: _vm.isLoading,
                      isRounded: true,
                      handleClick: _vm.invalidateAccountVerification
                    }
                  },
                  [_vm._v("\n        Invalidate Verification\n      ")]
                )
              ],
              1
            )
          ])
        : _c("div", { staticClass: "invalidate-success" }, [
            _c("h1", [_vm._v("Success")]),
            _vm._v(" "),
            _c("p", [
              _vm._v("Your account verification request has been invalidated.")
            ])
          ]),
      _vm._v(" "),
      _c(
        "KToaster",
        _vm._b(
          {
            attrs: { isVisible: _vm.isToasterVisible },
            on: { close: _vm.closeToaster }
          },
          "KToaster",
          this.toaster,
          false
        )
      )
    ],
    1
  )
}
var staticRenderFns = []
render._withStripped = true

if (false) {
  module.hot.accept()
  if (module.hot.data) {
    require("vue-hot-reload-api")      .rerender("data-v-67e8859a", { render: render, staticRenderFns: staticRenderFns })
  }
}

/***/ }),

/***/ 1997:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return render; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "b", function() { return staticRenderFns; });
var render = function() {
  var _vm = this
  var _h = _vm.$createElement
  var _c = _vm._self._c || _h
  return _c(
    "div",
    { attrs: { id: "dashboard-wrapper" } },
    [
      _vm.route === "dashboard"
        ? _c("Dashboard", { attrs: { title: "API Credentials" } })
        : _vm._e(),
      _vm._v(" "),
      _vm.route === "settings" ? _c("Settings") : _vm._e(),
      _vm._v(" "),
      _vm.route === "reset-password" ? _c("ResetPassword") : _vm._e(),
      _vm._v(" "),
      _vm.route === "verify-account" ? _c("VerifyAccount") : _vm._e(),
      _vm._v(" "),
      _vm.route === "resend-account-verification"
        ? _c("ResendAccountVerification")
        : _vm._e(),
      _vm._v(" "),
      _vm.route === "invalidate-account-verification"
        ? _c("InvalidateAccountVerification")
        : _vm._e()
    ],
    1
  )
}
var staticRenderFns = []
render._withStripped = true

if (false) {
  module.hot.accept()
  if (module.hot.data) {
    require("vue-hot-reload-api")      .rerender("data-v-04878599", { render: render, staticRenderFns: staticRenderFns })
  }
}

/***/ }),

/***/ 42:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GET_CONFIG_URL = exports.KONG_CONFIGS = undefined;
exports.GET_CONFIG = GET_CONFIG;

var _common = __webpack_require__(17);

var KONG_CONFIGS = {
  PORTAL_AUTH: null,
  PORTAL_API_URL: null,
  PORTAL_API_PORT: '8004',
  PORTAL_API_SSL_PORT: '8447',
  PORTAL_GUI_URL: 'http://127.0.0.1:8003',
  PORTAL_GUI_PORT: '8003',
  PORTAL_GUI_SSL_PORT: '8443',
  PORTAL_IS_AUTHENTICATED: false,
  PORTAL_GUI_USE_SUBDOMAINS: false,
  RBAC_ENFORCED: 'false',
  RBAC_HEADER: 'Kong-Admin-Token',
  KONG_VERSION: 'false',
  WORKSPACE: 'default',
  PORTAL_DEVELOPER_META_FIELDS: [{
    label: 'Full Name',
    title: 'full_name',
    validator: {
      required: true,
      type: 'string'
    }
  }]
};

window.K_CONFIG = ['PORTAL_AUTH', 'PORTAL_API_URL', 'PORTAL_GUI_SSL_PORT', 'RBAC_HEADER', 'KONG_VERSION', 'PORTAL_GUI_PORT', 'PORTAL_API_SSL_PORT', 'PORTAL_GUI_URL', 'PORTAL_API_PORT', 'PORTAL_IS_AUTHENTICATED', 'PORTAL_GUI_USE_SUBDOMAINS', 'RBAC_ENFORCED', 'WORKSPACE', 'PORTAL_DEVELOPER_META_FIELDS'].reduce(function (acc, key) {
  acc[key] = (0, _common.getMetaTagContent)('KONG:' + key, KONG_CONFIGS[key]);

  if (key === 'PORTAL_DEVELOPER_META_FIELDS') {
    try {
      acc[key] = JSON.parse(acc[key]);
    } catch (e) {
      acc[key] = [];
    }
  }

  return acc;
}, {});

function GET_CONFIG_URL() {
  var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'API';

  var typeU = type.toUpperCase();

  if (['API', 'GUI'].indexOf(typeU) === -1) {
    throw new Error('Not a valid uri config type.');
  }

  var port = window.location.protocol.toLowerCase() === 'https:' ? GET_CONFIG('PORTAL_' + typeU + '_SSL_PORT') : GET_CONFIG('PORTAL_' + typeU + '_PORT');
  var baseUrl = window.location.protocol + '//' + window.location.hostname + ':' + port;

  return GET_CONFIG('PORTAL_' + typeU + '_URL') || baseUrl;
}

function GET_CONFIG(name) {
  var value = window.K_CONFIG ? window.K_CONFIG[name] : null;

  if (value === '' || value == null) {
    return KONG_CONFIGS[name] ? KONG_CONFIGS[name] : '';
  }

  try {
    return JSON.parse(value);
  } catch (e) {
    return value;
  }
}

window.GET_CONFIG = GET_CONFIG;

exports.KONG_CONFIGS = KONG_CONFIGS;
exports.GET_CONFIG_URL = GET_CONFIG_URL;

/***/ }),

/***/ 49:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty2 = __webpack_require__(127);

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _regenerator = __webpack_require__(94);

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = __webpack_require__(95);

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = __webpack_require__(124);

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = __webpack_require__(125);

var _createClass3 = _interopRequireDefault(_createClass2);

var _axios = __webpack_require__(256);

var _axios2 = _interopRequireDefault(_axios);

var _config = __webpack_require__(42);

var _constants = __webpack_require__(126);

var _common = __webpack_require__(17);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var baseURL = '' + (0, _config.GET_CONFIG_URL)('API');

var Api = function () {
  function Api() {
    (0, _classCallCheck3.default)(this, Api);
  }

  (0, _createClass3.default)(Api, null, [{
    key: 'login',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(axiosConfig) {
        var resp, url;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                resp = { data: [], status: 200 };
                _context.prev = 1;
                url = (0, _common.getWorkspaceURL)(baseURL, '/auth');
                _context.next = 5;
                return _axios2.default.get(url, axiosConfig);

              case 5:
                resp = _context.sent;
                _context.next = 13;
                break;

              case 8:
                _context.prev = 8;
                _context.t0 = _context['catch'](1);

                resp.data = [];
                resp.response = _context.t0.response;
                resp.status = _context.t0.response && _context.t0.response.status ? _context.t0.response.status : -1;

              case 13:
                return _context.abrupt('return', resp);

              case 14:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this, [[1, 8]]);
      }));

      function login(_x) {
        return _ref.apply(this, arguments);
      }

      return login;
    }()
  }, {
    key: 'getFiles',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(_ref3) {
        var axiosConfig = _ref3.axiosConfig,
            _ref3$route = _ref3.route,
            route = _ref3$route === undefined ? _constants.ROUTES.files + '?size=100' : _ref3$route;
        var resp, url, offset, arr;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                resp = { data: [], status: 200 };
                _context2.prev = 1;
                url = (0, _common.getWorkspaceURL)(baseURL, route);
                offset = void 0;
                arr = [];

              case 5:
                _context2.next = 7;
                return _axios2.default.get(offset ? url + '&offset=' + offset : url, axiosConfig);

              case 7:
                resp = _context2.sent;

                offset = resp.data.offset;
                arr = arr.concat(resp.data.data || [resp.data]);

              case 10:
                if (offset) {
                  _context2.next = 5;
                  break;
                }

              case 11:

                resp.data = arr;
                _context2.next = 19;
                break;

              case 14:
                _context2.prev = 14;
                _context2.t0 = _context2['catch'](1);

                resp.data = [];
                resp.response = _context2.t0.response;
                resp.status = _context2.t0.response && _context2.t0.response.status ? _context2.t0.response.status : -1;

              case 19:
                return _context2.abrupt('return', resp);

              case 20:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this, [[1, 14]]);
      }));

      function getFiles(_x2) {
        return _ref2.apply(this, arguments);
      }

      return getFiles;
    }()
  }, {
    key: 'register',
    value: function register(email, passwordKey, passwordValue, meta) {
      var _axios$post;

      var url = (0, _common.getWorkspaceURL)(baseURL, _constants.ROUTES.register);
      return _axios2.default.post(url, (_axios$post = { email: email }, (0, _defineProperty3.default)(_axios$post, passwordKey, passwordValue), (0, _defineProperty3.default)(_axios$post, 'meta', meta), _axios$post));
    }
  }, {
    key: 'get',
    value: function () {
      var _ref4 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(path, axiosConfig, transformResponse) {
        var resp, url;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                resp = { data: [], status: 200 };
                _context3.prev = 1;
                url = (0, _common.getWorkspaceURL)(baseURL, path);
                _context3.next = 5;
                return _axios2.default.get(url, axiosConfig);

              case 5:
                resp = _context3.sent;

                if (transformResponse) {
                  resp = transformResponse(resp);
                }
                resp.status = 200;
                _context3.next = 15;
                break;

              case 10:
                _context3.prev = 10;
                _context3.t0 = _context3['catch'](1);

                resp.data = [];
                resp.response = _context3.t0.response;
                resp.status = _context3.t0.response && _context3.t0.response.status ? _context3.t0.response.status : -1;

              case 15:
                return _context3.abrupt('return', resp);

              case 16:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this, [[1, 10]]);
      }));

      function get(_x3, _x4, _x5) {
        return _ref4.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: 'post',
    value: function () {
      var _ref5 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(path, options, axiosConfig, transformResponse) {
        var resp, url;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                resp = { data: [], status: 200 };
                _context4.prev = 1;
                url = (0, _common.getWorkspaceURL)(baseURL, path);
                _context4.next = 5;
                return _axios2.default.post(url, options, axiosConfig);

              case 5:
                resp = _context4.sent;

                if (transformResponse) {
                  resp = transformResponse(resp);
                }
                resp.status = 200;
                _context4.next = 15;
                break;

              case 10:
                _context4.prev = 10;
                _context4.t0 = _context4['catch'](1);

                resp.data = [];
                resp.response = _context4.t0.response;
                resp.status = _context4.t0.response && _context4.t0.response.status ? _context4.t0.response.status : -1;

              case 15:
                return _context4.abrupt('return', resp);

              case 16:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this, [[1, 10]]);
      }));

      function post(_x6, _x7, _x8, _x9) {
        return _ref5.apply(this, arguments);
      }

      return post;
    }()
  }, {
    key: 'put',
    value: function () {
      var _ref6 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(path, options, axiosConfig, transformResponse) {
        var resp, url;
        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                resp = { data: [], status: 200 };
                _context5.prev = 1;
                url = (0, _common.getWorkspaceURL)(baseURL, path);
                _context5.next = 5;
                return _axios2.default.put(url, options, axiosConfig);

              case 5:
                resp = _context5.sent;

                if (transformResponse) {
                  resp = transformResponse(resp);
                }
                resp.status = 200;
                _context5.next = 15;
                break;

              case 10:
                _context5.prev = 10;
                _context5.t0 = _context5['catch'](1);

                resp.data = [];
                resp.response = _context5.t0.response;
                resp.status = _context5.t0.response && _context5.t0.response.status ? _context5.t0.response.status : -1;

              case 15:
                return _context5.abrupt('return', resp);

              case 16:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this, [[1, 10]]);
      }));

      function put(_x10, _x11, _x12, _x13) {
        return _ref6.apply(this, arguments);
      }

      return put;
    }()
  }, {
    key: 'patch',
    value: function () {
      var _ref7 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(path, options, axiosConfig, transformResponse) {
        var resp, url;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                resp = { data: [], status: 200 };
                _context6.prev = 1;
                url = (0, _common.getWorkspaceURL)(baseURL, path);
                _context6.next = 5;
                return _axios2.default.patch(url, options, axiosConfig);

              case 5:
                resp = _context6.sent;

                if (transformResponse) {
                  resp = transformResponse(resp);
                }
                resp.status = 200;
                _context6.next = 15;
                break;

              case 10:
                _context6.prev = 10;
                _context6.t0 = _context6['catch'](1);

                resp.data = [];
                resp.response = _context6.t0.response;
                resp.status = _context6.t0.response && _context6.t0.response.status ? _context6.t0.response.status : -1;

              case 15:
                return _context6.abrupt('return', resp);

              case 16:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this, [[1, 10]]);
      }));

      function patch(_x14, _x15, _x16, _x17) {
        return _ref7.apply(this, arguments);
      }

      return patch;
    }()
  }, {
    key: 'delete',
    value: function () {
      var _ref8 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee7(path, axiosConfig, transformResponse) {
        var resp, url;
        return _regenerator2.default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                resp = { data: [], status: 200 };
                _context7.prev = 1;
                url = (0, _common.getWorkspaceURL)(baseURL, path);
                _context7.next = 5;
                return _axios2.default.delete(url, axiosConfig);

              case 5:
                resp = _context7.sent;

                if (transformResponse) {
                  resp = transformResponse(resp);
                }
                resp.status = 200;
                _context7.next = 15;
                break;

              case 10:
                _context7.prev = 10;
                _context7.t0 = _context7['catch'](1);

                resp.data = [];
                resp.response = _context7.t0.response;
                resp.status = _context7.t0.response && _context7.t0.response.status ? _context7.t0.response.status : -1;

              case 15:
                return _context7.abrupt('return', resp);

              case 16:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this, [[1, 10]]);
      }));

      function _delete(_x18, _x19, _x20) {
        return _ref8.apply(this, arguments);
      }

      return _delete;
    }()
  }]);
  return Api;
}();

exports.default = Api;

/***/ }),

/***/ 743:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _Dashboard = __webpack_require__(1836);

var _Dashboard2 = _interopRequireDefault(_Dashboard);

var _Settings = __webpack_require__(1974);

var _Settings2 = _interopRequireDefault(_Settings);

var _ResetPassword = __webpack_require__(1981);

var _ResetPassword2 = _interopRequireDefault(_ResetPassword);

var _VerifyAccount = __webpack_require__(1985);

var _VerifyAccount2 = _interopRequireDefault(_VerifyAccount);

var _ResendAccountVerification = __webpack_require__(1989);

var _ResendAccountVerification2 = _interopRequireDefault(_ResendAccountVerification);

var _InvalidateAccountVerification = __webpack_require__(1993);

var _InvalidateAccountVerification2 = _interopRequireDefault(_InvalidateAccountVerification);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  name: 'app',

  components: {
    Dashboard: _Dashboard2.default,
    Settings: _Settings2.default,
    ResetPassword: _ResetPassword2.default,
    VerifyAccount: _VerifyAccount2.default,
    ResendAccountVerification: _ResendAccountVerification2.default,
    InvalidateAccountVerification: _InvalidateAccountVerification2.default
  },

  data: function data() {
    return {};
  },


  computed: {
    route: function route() {
      return document.getElementById('portal-dashboard').getAttribute('page');
    }
  }
};

/***/ }),

/***/ 744:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(46);

var _extends3 = _interopRequireDefault(_extends2);

var _keys = __webpack_require__(48);

var _keys2 = _interopRequireDefault(_keys);

var _Api = __webpack_require__(49);

var _Api2 = _interopRequireDefault(_Api);

var _CredentialTable = __webpack_require__(1839);

var _CredentialTable2 = _interopRequireDefault(_CredentialTable);

var _CredentialFormModal = __webpack_require__(746);

var _CredentialFormModal2 = _interopRequireDefault(_CredentialFormModal);

var _DevRequestsChart = __webpack_require__(1861);

var _DevRequestsChart2 = _interopRequireDefault(_DevRequestsChart);

var _kbutton = __webpack_require__(78);

var _kbutton2 = _interopRequireDefault(_kbutton);

var _kmodal = __webpack_require__(312);

var _kmodal2 = _interopRequireDefault(_kmodal);

var _ktable = __webpack_require__(537);

var _ktable2 = _interopRequireDefault(_ktable);

var _ktoaster = __webpack_require__(108);

var _ktoaster2 = _interopRequireDefault(_ktoaster);

var _plugins = __webpack_require__(1972);

var _plugins2 = _interopRequireDefault(_plugins);

var _toaster = __webpack_require__(109);

var _toaster2 = _interopRequireDefault(_toaster);

var _common = __webpack_require__(17);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  name: 'Dashboard',
  mixins: [_toaster2.default],
  components: { CredentialFormModal: _CredentialFormModal2.default, CredentialTable: _CredentialTable2.default, DevRequestsChart: _DevRequestsChart2.default, KTable: _ktable2.default, KModal: _kmodal2.default, KButton: _kbutton2.default, KToaster: _ktoaster2.default },

  props: ['title'],

  data: function data() {
    return {
      authTypes: (0, _keys2.default)(_plugins2.default),
      credentials: [],
      showEmpty: true,
      selectedRow: null,
      openModal: null,
      plugins: _plugins2.default,
      axiosConfig: { withCredentials: true }
    };
  },
  mounted: function mounted() {
    this.fetchData();
  },


  methods: {
    fetchData: function fetchData() {
      this.getCredentialTypes();
    },
    getCredentialTypes: function getCredentialTypes() {
      var _this = this;

      var transformResponse = function transformResponse(resp) {
        resp.data = resp.data && resp.data.plugins ? resp.data.plugins['enabled_in_cluster'] : [];

        resp.data = Array.isArray(resp.data) ? resp.data : [];
        return resp;
      };

      _Api2.default.get('/config', this.axiosConfig, transformResponse).then(function (resp) {
        _this.credentials = resp.data && resp.data.map(function (pluginType) {
          return _plugins2.default[pluginType];
        }).filter(function (c) {
          return !!c;
        }) || [];

        _this.showEmpty = _this.credentials.length === 0;
      });
    },
    createCredential: function createCredential(model, authType) {
      var _this2 = this;

      var path = '/credentials' + _plugins2.default[authType].endpoint;
      var options = model;

      _Api2.default.post(path, options, this.axiosConfig).then(function (resp) {
        if (resp.status !== 200) {
          var message = (0, _common.getMessageFromError)(resp);
          _this2.showToaster((0, _extends3.default)({}, _this2.errorToaster, { message: message }));
          return;
        }
        _this2.$refs[authType][0].fetchData();
        _this2.showToaster(_this2.successToaster);
        _this2.closeModal();
      });
    },
    openShowModal: function openShowModal() {
      this.showModal('create');
    },
    showModal: function showModal(modal) {
      this.openModal = modal;
    },
    closeModal: function closeModal() {
      this.openModal = null;
    }
  }
};

/***/ }),

/***/ 745:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = __webpack_require__(48);

var _keys2 = _interopRequireDefault(_keys);

var _extends2 = __webpack_require__(46);

var _extends3 = _interopRequireDefault(_extends2);

var _Api = __webpack_require__(49);

var _Api2 = _interopRequireDefault(_Api);

var _CredentialFormModal = __webpack_require__(746);

var _CredentialFormModal2 = _interopRequireDefault(_CredentialFormModal);

var _kbutton = __webpack_require__(78);

var _kbutton2 = _interopRequireDefault(_kbutton);

var _kmodal = __webpack_require__(312);

var _kmodal2 = _interopRequireDefault(_kmodal);

var _ktable = __webpack_require__(537);

var _ktable2 = _interopRequireDefault(_ktable);

var _ktoaster = __webpack_require__(108);

var _ktoaster2 = _interopRequireDefault(_ktoaster);

var _toaster = __webpack_require__(109);

var _toaster2 = _interopRequireDefault(_toaster);

var _common = __webpack_require__(17);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  name: 'credentialTable',
  mixins: [_toaster2.default],
  components: { CredentialFormModal: _CredentialFormModal2.default, KTable: _ktable2.default, KModal: _kmodal2.default, KButton: _kbutton2.default, KToaster: _ktoaster2.default },

  props: ['title', 'credentialOptions'],

  data: function data() {
    return {
      credentialList: {
        data: []
      },
      selectedRow: null,
      openModal: null,
      axiosConfig: { withCredentials: true }
    };
  },
  mounted: function mounted() {
    this.fetchData();
  },


  methods: {
    fetchData: function fetchData() {
      this.getCredentials();
    },
    getCredentials: function getCredentials() {
      var _this = this;

      var path = '/credentials' + this.credentialOptions.endpoint;

      _Api2.default.get(path, this.axiosConfig).then(function (resp) {
        if (resp.status !== 200) {
          _this.showToaster((0, _extends3.default)({}, _this.errorToaster, { message: (0, _common.getMessageFromError)(resp) }));
          return;
        }
        _this.buildCredentialList(resp);
      });
    },
    updateCredential: function updateCredential(model) {
      var _this2 = this;

      var path = '/credentials' + this.credentialOptions.endpoint + '/' + this.selectedRow.credential.id;
      var params = model;

      _Api2.default.patch(path, params, this.axiosConfig).then(function (resp) {
        if (resp.status !== 200) {
          _this2.showToaster((0, _extends3.default)({}, _this2.errorToaster, { message: (0, _common.getMessageFromError)(resp) }));
          return;
        }
        _this2.showToaster(_this2.successToaster);
        _this2.closeModal();
        _this2.fetchData();
      });
    },
    deleteCredential: function deleteCredential() {
      var _this3 = this;

      var path = '/credentials' + this.credentialOptions.endpoint + '/' + this.selectedRow.credential.id;

      _Api2.default.delete(path, this.axiosConfig).then(function (resp) {
        if (resp.status !== 200) {
          var toasterMessage = (0, _common.getMessageFromError)(resp);
          _this3.showToaster((0, _extends3.default)({}, _this3.errorToaster, { message: toasterMessage }));
          return;
        }
        _this3.showToaster(_this3.successToaster);
        _this3.closeModal();
        _this3.fetchData();
      });
    },
    showModal: function showModal(modal, row, rowKey) {
      this.selectedRow = {
        modal: modal,
        key: rowKey,
        plugin: this.credentialOptions,
        credential: this.credentialList.data[rowKey]
      };
    },
    closeModal: function closeModal() {
      this.openModal = null;
      this.selectedRow = null;
    },
    buildCredentialList: function buildCredentialList(resp) {
      var headers = (0, _keys2.default)(this.credentialOptions.fields).map(function (field) {
        return { label: field, key: field };
      });
      headers.push({ label: '', key: 'actions', hideLabel: true });

      var credentialsData = resp.data.data.map(function (cred) {
        return typeof cred === 'string' ? JSON.parse(cred) : cred;
      });

      this.credentialList = {
        headers: headers,
        data: credentialsData
      };
    }
  },

  watch: {
    credentialList: {
      handler: function handler() {},
      deep: true
    }
  }
};

/***/ }),

/***/ 746:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialFormModal_vue__ = __webpack_require__(747);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialFormModal_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialFormModal_vue__);
/* harmony namespace reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialFormModal_vue__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialFormModal_vue__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_2f81d49e_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_CredentialFormModal_vue__ = __webpack_require__(1853);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__ = __webpack_require__(31);
var disposed = false
function injectStyle (context) {
  if (disposed) return
  __webpack_require__(1842)
}
/* script */


/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = injectStyle
/* scopeId */
var __vue_scopeId__ = "data-v-2f81d49e"
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null

var Component = Object(__WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__["a" /* default */])(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialFormModal_vue___default.a,
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_2f81d49e_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_CredentialFormModal_vue__["a" /* render */],
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_2f81d49e_hasScoped_true_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_CredentialFormModal_vue__["b" /* staticRenderFns */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src/js/dashboard/components/CredentialFormModal.vue"

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-2f81d49e", Component.options)
  } else {
    hotAPI.reload("data-v-2f81d49e", Component.options)
  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["default"] = (Component.exports);


/***/ }),

/***/ 747:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = __webpack_require__(123);

var _assign2 = _interopRequireDefault(_assign);

var _kbutton = __webpack_require__(78);

var _kbutton2 = _interopRequireDefault(_kbutton);

var _kmodal = __webpack_require__(312);

var _kmodal2 = _interopRequireDefault(_kmodal);

var _CredentialForm = __webpack_require__(750);

var _CredentialForm2 = _interopRequireDefault(_CredentialForm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  name: 'credentialFormModal',
  components: { KButton: _kbutton2.default, KModal: _kmodal2.default, CredentialForm: _CredentialForm2.default },

  props: {
    plugins: {
      type: Array,
      required: true
    },
    authType: {
      type: String
    },
    actionType: {
      type: String,
      required: true
    },
    isVisible: {
      type: Boolean,
      default: false
    },
    model: {
      type: Object
    },
    submitModalCallback: {
      type: Function,
      required: true
    }
  },

  data: function data() {
    return {
      formType: this.authType || this.plugins[0].plugin,
      formModel: (0, _assign2.default)({}, this.model) || {},
      submitButtonAttributes: { type: 'submit' },
      triggerSubmit: false
    };
  },


  methods: {
    submitForm: function submitForm() {
      this.triggerSubmit = true;
    },
    submitModal: function submitModal(status) {
      this.triggerSubmit = false;
      if (status) {
        this.submitModalCallback(this.formModel, this.formType);
      }
    },
    closeModal: function closeModal() {
      this.$emit('close');
    }
  },

  computed: {
    formSchema: function formSchema() {
      var _this = this;

      return this.plugins.find(function (plugin) {
        return plugin.plugin === _this.formType;
      });
    }
  },

  watch: {
    formType: function formType() {
      this.formModel = {};
    }
  }
};

/***/ }),

/***/ 750:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialForm_vue__ = __webpack_require__(751);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialForm_vue___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialForm_vue__);
/* harmony namespace reexport (unknown) */ for(var __WEBPACK_IMPORT_KEY__ in __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialForm_vue__) if(__WEBPACK_IMPORT_KEY__ !== 'default') (function(key) { __webpack_require__.d(__webpack_exports__, key, function() { return __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialForm_vue__[key]; }) }(__WEBPACK_IMPORT_KEY__));
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_1297d7e8_hasScoped_false_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_CredentialForm_vue__ = __webpack_require__(1852);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__ = __webpack_require__(31);
var disposed = false
function injectStyle (context) {
  if (disposed) return
  __webpack_require__(1850)
}
/* script */


/* template */

/* template functional */
var __vue_template_functional__ = false
/* styles */
var __vue_styles__ = injectStyle
/* scopeId */
var __vue_scopeId__ = null
/* moduleIdentifier (server only) */
var __vue_module_identifier__ = null

var Component = Object(__WEBPACK_IMPORTED_MODULE_2__node_modules_vue_loader_lib_runtime_component_normalizer__["a" /* default */])(
  __WEBPACK_IMPORTED_MODULE_0__babel_loader_node_modules_vue_loader_lib_selector_type_script_index_0_CredentialForm_vue___default.a,
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_1297d7e8_hasScoped_false_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_CredentialForm_vue__["a" /* render */],
  __WEBPACK_IMPORTED_MODULE_1__node_modules_vue_loader_lib_template_compiler_index_id_data_v_1297d7e8_hasScoped_false_optionsId_0_buble_transforms_node_modules_vue_loader_lib_selector_type_template_index_0_CredentialForm_vue__["b" /* staticRenderFns */],
  __vue_template_functional__,
  __vue_styles__,
  __vue_scopeId__,
  __vue_module_identifier__
)
Component.options.__file = "src/js/dashboard/components/CredentialForm.vue"

/* hot reload */
if (false) {(function () {
  var hotAPI = require("vue-hot-reload-api")
  hotAPI.install(require("vue"), false)
  if (!hotAPI.compatible) return
  module.hot.accept()
  if (!module.hot.data) {
    hotAPI.createRecord("data-v-1297d7e8", Component.options)
  } else {
    hotAPI.reload("data-v-1297d7e8", Component.options)
  }
  module.hot.dispose(function (data) {
    disposed = true
  })
})()}

/* harmony default export */ __webpack_exports__["default"] = (Component.exports);


/***/ }),

/***/ 751:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = __webpack_require__(48);

var _keys2 = _interopRequireDefault(_keys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  name: 'credentialForm',

  props: {
    schema: {
      type: Object,
      required: true
    },
    model: {
      type: Object,
      required: true
    },
    actionType: {
      type: String,
      required: true
    },
    triggerSubmit: {
      type: Boolean,
      required: true
    },
    isDisabled: {
      type: Boolean,
      default: false
    },
    onSubmit: {
      type: Function,
      default: function _default() {}
    }
  },

  data: function data() {
    return {
      passwordConfirm: '',
      isPasswordVisible: this.actionType === 'create' || this.actionType === 'simple',
      hasError: false
    };
  },


  computed: {
    inEditMode: function inEditMode() {
      return this.actionType === 'edit';
    },
    inCreateMode: function inCreateMode() {
      return this.actionType === 'create';
    }
  },

  methods: {
    validateAndSubmit: function validateAndSubmit() {
      var _this = this;

      var schemaFields = this.schema.fields;
      (0, _keys2.default)(this.model).forEach(function (key) {
        if (schemaFields[key] && schemaFields[key].inputType === 'array' && typeof _this.model[key] === 'string') {
          _this.model[key] = _this.model[key].replace(/\s/g, "").split(',');
        }
      });

      if (this.schema.plugin === 'basic-auth' && this.actionType === 'edit') {
        if (this.model.password === this.passwordConfirm) {
          this.onSubmit(true);
        } else {
          this.hasError = true;
          this.onSubmit(false);
        }
      } else {
        this.onSubmit(true);
      }
    }
  },

  watch: {
    triggerSubmit: function triggerSubmit(value) {
      if (value) {
        this.validateAndSubmit();
      }
    }
  },

  created: function created() {
    if (this.schema.plugin === 'basic-auth') {
      this.model.password = '';
    }
  }
};

/***/ }),

/***/ 754:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(46);

var _extends3 = _interopRequireDefault(_extends2);

var _assign = __webpack_require__(123);

var _assign2 = _interopRequireDefault(_assign);

var _Api = __webpack_require__(49);

var _Api2 = _interopRequireDefault(_Api);

var _vitals = __webpack_require__(755);

var _LineChart = __webpack_require__(1865);

var _LineChart2 = _interopRequireDefault(_LineChart);

var _ChartControls = __webpack_require__(1962);

var _ChartControls2 = _interopRequireDefault(_ChartControls);

var _ChartTooltip = __webpack_require__(1966);

var _ChartTooltip2 = _interopRequireDefault(_ChartTooltip);

var _ktoaster = __webpack_require__(108);

var _ktoaster2 = _interopRequireDefault(_ktoaster);

var _toaster = __webpack_require__(109);

var _toaster2 = _interopRequireDefault(_toaster);

var _polling = __webpack_require__(1970);

var _polling2 = _interopRequireDefault(_polling);

var _common = __webpack_require__(17);

var _get2 = __webpack_require__(567);

var _get3 = _interopRequireDefault(_get2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  name: 'DevRequestsChart',
  mixins: [_toaster2.default, _polling2.default],
  components: { LineChart: _LineChart2.default, ChartTooltip: _ChartTooltip2.default, KToaster: _ktoaster2.default, ChartControls: _ChartControls2.default },

  props: {
    axiosConfig: {
      type: Object,
      required: true
    },
    height: {
      type: Number,
      default: 250
    }
  },

  data: function data() {
    var _this = this;

    return {
      vitalsEnabled: false,
      timeFrame: _vitals.TIME_FRAMES[0].value,
      isUtc: false,
      chartData: {},
      lineColor: 'rgba(20, 128, 204, 1)',
      fillColor: 'rgba(242, 250, 255, 0.5)',
      pointBorderColor: 'rgba(255, 255, 255, 1)',
      totalRequests: 0,
      tooltipConfig: null,
      options: {
        tooltips: {
          custom: function () {
            var vm = _this;
            return function (tooltipModel) {
              var rect = this._chart.canvas.getBoundingClientRect();

              vm.tooltipConfig = {
                tooltipModel: tooltipModel,
                eventX: this._chart.tooltip._eventPosition.x,
                chartWidth: rect.width
              };
            };
          }()
        },
        scales: {
          yAxes: [{
            ticks: {
              callback: _vitals.toAbbreviatedString
            }
          }]
        }
      }
    };
  },


  watch: {
    timeFrame: {
      immediate: true,
      handler: function handler(timeFrame) {
        this.fetchData(timeFrame);
      }
    },

    isUtc: {
      handler: function handler() {
        this.redraw();
      }
    }
  },

  computed: {
    requestsText: function requestsText() {
      return this.totalRequests === 1 ? 'request' : 'requests';
    }
  },

  methods: {
    handleControlChange: function handleControlChange(key, value) {
      this[key] = value;
    },
    redraw: function redraw() {
      this.chartData = (0, _assign2.default)({}, this.chartData);
    },
    fetchData: function fetchData(timeFrame) {
      var _this2 = this;

      this.setPolling(function () {
        return _this2.fetchData(timeFrame);
      }, timeFrame.refreshInterval);

      var param = timeFrame.param;

      var _getTimeBounds = (0, _vitals.getTimeBounds)(timeFrame),
          startTs = _getTimeBounds.startTs,
          endTs = _getTimeBounds.endTs;

      var path = '/vitals/consumers/cluster?interval=' + param + '&start_ts=' + startTs;

      return _Api2.default.get(path, this.axiosConfig).then(function (resp) {
        if (resp.status !== 200) {
          _this2.teardownPolling();
          _this2.showToaster((0, _extends3.default)({}, _this2.errorToaster, { message: (0, _common.getMessageFromError)(resp) }));
          return;
        }

        _this2.vitalsEnabled = true;

        if (param !== _this2.timeFrame.param) {
          return;
        }

        var clusterStats = (0, _get3.default)(resp, 'data.stats.cluster', {});
        var meta = (0, _get3.default)(resp, 'data.meta', {});

        var _getTimeBounds2 = (0, _vitals.getTimeBounds)(timeFrame, endTs, meta.interval_width),
            startTs = _getTimeBounds2.startTs,
            endTs = _getTimeBounds2.endTs,
            stepSize = _getTimeBounds2.stepSize;

        var _getTimeRange = (0, _vitals.getTimeRange)(startTs, endTs, stepSize, timeFrame.ticksMod),
            labels = _getTimeRange.labels,
            range = _getTimeRange.range;

        var reducedTimeRange = range.reduce(function (acc, ts) {
          var requests = clusterStats[ts] || 0;
          acc.total += requests;
          acc.mappedData.push({ x: ts, y: requests });
          return acc;
        }, {
          total: 0,
          mappedData: []
        });

        _this2.totalRequests = reducedTimeRange.total;

        _this2.chartData = {
          labels: labels,
          datasets: [(0, _extends3.default)({
            label: 'Requests',
            data: reducedTimeRange.mappedData,
            yAxisID: 'main-y-axis',
            backgroundColor: _this2.fillColor,
            borderColor: _this2.lineColor,
            pointHoverBackgroundColor: _this2.lineColor,
            pointBorderColor: _this2.pointBorderColor
          }, _vitals.DATASET_DEFAULTS)]
        };
      });
    }
  }
};

/***/ }),

/***/ 755:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DATASET_DEFAULTS = exports.TIME_FRAMES = undefined;
exports.getTimeRange = getTimeRange;
exports.toAbbreviatedString = toAbbreviatedString;
exports.getTimeBounds = getTimeBounds;

var _moment = __webpack_require__(0);

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TIME_FRAMES = [{
  text: 'last 5 minutes',
  value: {
    text: 'last 5 minutes',
    timeFrameLength: 300,
    stepSize: 1,
    param: 'seconds',
    ticksMod: 60,
    refreshInterval: 5000
  }
}, {
  text: 'last 30 minutes',
  value: {
    text: 'last 30 minutes',
    timeFrameLength: 1800,
    stepSize: 60,
    param: 'minutes',
    ticksMod: 300,
    refreshInterval: 30000
  }
}, {
  text: 'last 60 minutes',
  value: {
    text: 'last 60 minutes',
    timeFrameLength: 3600,
    stepSize: 60,
    param: 'minutes',
    ticksMod: 900,
    refreshInterval: 60000
  }
}, {
  text: 'last 6 hours',
  value: {
    text: 'last 6 hours',
    timeFrameLength: 21600,
    stepSize: 60,
    param: 'minutes',
    ticksMod: 3600,
    refreshInterval: 360000
  }
}, {
  text: 'last 12 hours',
  value: {
    text: 'last 12 hours',
    timeFrameLength: 43200,
    stepSize: 60,
    param: 'minutes',
    ticksMod: 7200,
    refreshInterval: 720000
  }
}];

var DATASET_DEFAULTS = {
  lineTension: 0,
  borderWidth: 1.5,
  pointBorderWidth: 2.5,
  borderJoinStyle: 'round'
};

var NUMBER_ABRV = 'kmbt';

exports.TIME_FRAMES = TIME_FRAMES;
exports.DATASET_DEFAULTS = DATASET_DEFAULTS;
function getTimeRange(startTs, endTs, stepSize, ticksMod) {
  var range = [];
  var labels = [];

  for (var ts = startTs; ts <= endTs; ts += stepSize) {
    range.push(ts);

    if (ts % ticksMod === 0) {
      labels.push(ts);
    }
  }

  return { range: range, labels: labels };
}

function toAbbreviatedString(number) {
  var base = Math.floor(Math.log(Math.abs(number)) / Math.log(1000));
  var suffix = NUMBER_ABRV[base - 1];

  if (!suffix) {
    return '' + Math.floor(number * 10) / 10;
  }

  var rounded = Math.floor(number * 10 / Math.pow(1000, base)) / 10;
  return '' + rounded + suffix;
}

function getTimeBounds(timeFrame, endTs, stepSize) {
  stepSize = parseInt(stepSize || timeFrame.stepSize, 10);

  endTs = Math.floor((endTs || (0, _moment2.default)().unix() - 15) / stepSize) * stepSize;
  var startTs = endTs - timeFrame.timeFrameLength;

  return { startTs: startTs, endTs: endTs, stepSize: stepSize };
}

/***/ }),

/***/ 875:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defaultsDeep = __webpack_require__(1866);

var _defaultsDeep2 = _interopRequireDefault(_defaultsDeep);

var _moment = __webpack_require__(0);

var _moment2 = _interopRequireDefault(_moment);

var _vueChartjs = __webpack_require__(1905);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var reactiveProp = _vueChartjs.mixins.reactiveProp;
exports.default = _vueChartjs.Line.extend({
  mixins: [reactiveProp],

  props: {
    isUtc: {
      type: Boolean
    },
    options: {
      type: Object
    }
  },

  data: function data() {
    var _this = this;

    return {
      defaultOptions: {
        layout: {
          padding: {
            top: 0,
            bottom: 5,
            right: 0,
            left: 10
          }
        },
        legend: {
          display: false,
          position: 'bottom'
        },
        hover: {
          mode: 'index',
          intersect: false,
          animationDuration: 0
        },
        animation: {
          duration: 0
        },
        tooltips: {
          enabled: false,
          mode: 'index',
          intersect: false,
          titleFontSize: 8,
          bodyFontSize: 8,
          caretSize: 0,
          caretPadding: 0,
          xPadding: 0,
          filter: function filter(tooltipItem, chart) {
            return !isNaN(tooltipItem.yLabel) && !chart.datasets[tooltipItem.datasetIndex].hidden;
          }
        },
        elements: {
          point: {
            radius: 0,
            hitRadius: 4,
            hoverRadius: 4
          }
        },
        scales: {
          xAxes: [{
            gridLines: {
              display: false,
              drawTicks: false,
              drawBorder: false
            },
            ticks: {
              padding: 10,
              source: 'labels',
              autoSkip: false,
              display: true,
              callback: function callback(value, index, values) {
                value = (0, _moment2.default)(values[index].value);

                if (_this.isUtc) {
                  value = value.utc();
                }

                return value.format('h:mm:ss a');
              }
            },

            time: {
              tooltipFormat: 'h:mm:ss a',
              displayFormats: {
                second: 'h:mm:ss a',
                minute: 'h:mm:ss a'
              },
              parser: function parser(time) {
                time = _moment2.default.unix(time);
                if (_this.isUtc) {
                  time = time.utc();
                }

                return time;
              }
            },
            type: 'time'
          }],
          yAxes: [{
            id: 'main-y-axis',
            type: 'linear',
            ticks: {
              beginAtZero: true,
              padding: 10,
              maxTicksLimit: 5
            },
            gridLines: {
              zeroLineColor: 'rgba(0, 0, 0, 0.75)',
              zeroLineWidth: 0.5,
              drawBorder: false,
              display: true,
              drawTicks: false
            }
          }]
        },
        responsive: true,
        maintainAspectRatio: false
      }
    };
  },
  mounted: function mounted() {
    this.addPlugin({
      id: 'vertical-line',
      afterDatasetDraw: this.drawLine
    });

    this.renderChart(this.chartData, (0, _defaultsDeep2.default)({}, this.options, this.defaultOptions));
  },


  methods: {
    drawLine: function drawLine(chart) {
      if (chart.tooltip._active && chart.tooltip._active.length) {
        var activePoint = chart.tooltip._active.find(function (element) {
          return !element._model.skip;
        });
        if (!activePoint) {
          return;
        }

        var position = activePoint.tooltipPosition();
        if (!position) {
          return;
        }

        var x = position.x;
        var ctx = chart.ctx;
        var yAxis = chart.scales['main-y-axis'];

        var topY = yAxis.top;
        var bottomY = yAxis.bottom;

        ctx.save();
        ctx.beginPath();
        ctx.moveTo(x, topY);
        ctx.lineTo(x, bottomY);
        ctx.lineWidth = 1;
        ctx.strokeStyle = '#828282';
        ctx.stroke();
        ctx.restore();
      }
    }
  }
});

/***/ }),

/***/ 898:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = __webpack_require__(123);

var _assign2 = _interopRequireDefault(_assign);

var _vitals = __webpack_require__(755);

var _kbutton = __webpack_require__(78);

var _kbutton2 = _interopRequireDefault(_kbutton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  name: 'ChartControls',
  components: { KButton: _kbutton2.default },
  props: {
    timeFrame: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    isUtc: {
      type: Boolean,
      default: false
    },
    onChange: {
      type: Function,
      default: function _default() {}
    }
  },

  data: function data() {
    return {
      localTimeFrame: null,
      timeFrames: _vitals.TIME_FRAMES
    };
  },


  watch: {
    timeFrame: {
      immediate: true,
      handler: function handler(val) {
        this.localTimeFrame = (0, _assign2.default)({}, val);
      }
    }
  },

  methods: {
    toggleUtc: function toggleUtc() {
      this.onChange('isUtc', !this.isUtc);
    }
  }
};

/***/ }),

/***/ 899:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = {
  name: 'ChartTooltip',

  props: {
    tooltipConfig: {
      type: Object,
      default: null
    }
  },

  data: function data() {
    return {
      left: null,
      lastX: 0
    };
  },


  computed: {
    tooltipModel: function tooltipModel() {
      return this.tooltipConfig && this.tooltipConfig.tooltipModel || {};
    },
    showTooltip: function showTooltip() {
      return this.tooltipModel.opacity !== 0 && this.tooltipModel.dataPoints && this.tooltipModel.dataPoints[0];
    },
    displayTime: function displayTime() {
      return this.tooltipModel.title && this.tooltipModel.title[0] || '';
    },
    tooltipBody: function tooltipBody() {
      return this.tooltipModel.body || [];
    },
    top: function top() {
      return this.tooltipModel.caretY - this.tooltipModel.height + 'px';
    },
    tooltipStyle: function tooltipStyle() {
      return {
        top: this.top,
        left: this.left
      };
    }
  },

  watch: {
    tooltipBody: {
      handler: function handler() {
        var tooltipWidth = this.$refs.tooltip.clientWidth || 100;
        var xPos = this.tooltipConfig.eventX;
        var beforeLineX = xPos + tooltipWidth * -1.50;
        var afterLineX = xPos + tooltipWidth / 2;

        if (xPos > this.lastX) {
          this.left = (beforeLineX > 0 ? beforeLineX : afterLineX) + 'px';
        } else {
          this.left = (afterLineX + tooltipWidth < this.tooltipConfig.chartWidth ? afterLineX : beforeLineX) + 'px';
        }

        this.lastX = xPos;
      }
    }
  }
};

/***/ }),

/***/ 900:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = {
  username: {
    type: 'input',
    inputType: 'text'
  },

  password: {
    type: 'input',
    inputType: 'password'
  }
};

/***/ }),

/***/ 901:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = {
  key: {
    type: 'input',
    inputType: 'text'
  }
};

/***/ }),

/***/ 902:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = {
  name: {
    type: 'input',
    inputType: 'text'
  },
  client_id: {
    type: 'input',
    inputType: 'text'
  },
  client_secret: {
    type: 'input',
    inputType: 'text'
  },
  redirect_uris: {
    type: 'input',
    inputType: 'array'
  }
};

/***/ }),

/***/ 903:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = {
  username: {
    type: 'input',
    inputType: 'text'
  },
  secret: {
    type: 'input',
    inputType: 'text'
  }
};

/***/ }),

/***/ 904:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = {
  key: {
    type: 'input',
    inputType: 'text'
  },
  algorithm: {
    type: 'select',
    values: ['HS256', 'RS256', 'ES256']
  },
  rsa_public_key: {
    type: 'textArea',
    rows: 3
  },
  secret: {
    type: 'input',
    inputType: 'text'
  }
};

/***/ }),

/***/ 905:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = __webpack_require__(68);

var _stringify2 = _interopRequireDefault(_stringify);

var _keys = __webpack_require__(48);

var _keys2 = _interopRequireDefault(_keys);

var _regenerator = __webpack_require__(94);

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = __webpack_require__(95);

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = __webpack_require__(46);

var _extends3 = _interopRequireDefault(_extends2);

var _assign = __webpack_require__(123);

var _assign2 = _interopRequireDefault(_assign);

var _promise = __webpack_require__(249);

var _promise2 = _interopRequireDefault(_promise);

var _async = __webpack_require__(1979);

var _async2 = _interopRequireDefault(_async);

var _Api = __webpack_require__(49);

var _Api2 = _interopRequireDefault(_Api);

var _CredentialForm = __webpack_require__(750);

var _CredentialForm2 = _interopRequireDefault(_CredentialForm);

var _kbutton = __webpack_require__(78);

var _kbutton2 = _interopRequireDefault(_kbutton);

var _kmodal = __webpack_require__(312);

var _kmodal2 = _interopRequireDefault(_kmodal);

var _ktable = __webpack_require__(537);

var _ktable2 = _interopRequireDefault(_ktable);

var _ktoaster = __webpack_require__(108);

var _ktoaster2 = _interopRequireDefault(_ktoaster);

var _toaster = __webpack_require__(109);

var _toaster2 = _interopRequireDefault(_toaster);

var _common = __webpack_require__(17);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  name: 'Settings',
  mixins: [_toaster2.default],
  components: { CredentialForm: _CredentialForm2.default, KTable: _ktable2.default, KModal: _kmodal2.default, KButton: _kbutton2.default, KToaster: _ktoaster2.default },

  data: function data() {
    return {
      axiosConfig: { withCredentials: true },
      formType: window.K_CONFIG && window.K_CONFIG.PORTAL_AUTH,
      showModal: false,
      renderForm: false,

      userInfoData: null,
      infoFormModel: null,
      isEditingInfoForm: false,
      canUpdateInfo: false,
      triggerInfoFormSubmit: false,

      credentialFormModel: {},
      isEditingCredentialForm: false,
      canUpdateCredential: false,
      triggerCredentialFormSubmit: false,

      infoFormSchema: {
        fields: {
          email: {
            type: 'input',
            inputType: 'text'
          }
        }
      },
      basicAuthSchema: {
        fields: {
          password: {
            type: 'input',
            inputType: 'password',
            label: 'Current Password'
          },
          new_password: {
            type: 'input',
            inputType: 'password',
            label: 'New Password'
          },
          confirm_password: {
            type: 'input',
            inputType: 'password',
            label: 'Confirm Password'
          }
        }
      },
      keyAuthSchema: {
        fields: {
          key: {
            type: 'input',
            inputType: 'text',
            label: 'Current Key'
          },
          new_key: {
            type: 'input',
            inputType: 'text',
            label: 'New Key'
          }
        }
      }
    };
  },
  mounted: function mounted() {
    var _this = this;

    _promise2.default.all([this.fetchExtraFields(), this.fetchUserData()]).then(function () {
      _this.renderForm = true;
    });
  },


  methods: {
    toggleInfoFormEdit: function toggleInfoFormEdit() {
      this.isEditingInfoForm = !this.isEditingInfoForm;
    },
    toggleCredentialFormEdit: function toggleCredentialFormEdit() {
      this.isEditingCredentialForm = !this.isEditingCredentialForm;
    },
    cancelUpdateInfo: function cancelUpdateInfo() {
      this.triggerInfoFormSubmit = false;
      this.canUpdateInfo = false;
      this.isEditingInfoForm = false;
      this.infoFormModel = (0, _assign2.default)({}, this.userInfoData);
    },
    cancelUpdateCredential: function cancelUpdateCredential() {
      this.triggerCredentialFormSubmit = false;
      this.isEditingCredentialForm = false;
      this.credentialFormModel = {};
    },
    submitInfoForm: function submitInfoForm() {
      if (this.canUpdateInfo) {
        this.triggerInfoFormSubmit = true;
      }
    },
    submitCredentialForm: function submitCredentialForm() {
      switch (this.formType) {
        case 'basic-auth':
          if (this.credentialFormModel.new_password !== this.credentialFormModel.confirm_password) {
            this.showToaster((0, _extends3.default)({}, this.errorToaster, { message: 'passwords do not match' }));
            return;
          }
          break;

        case 'key-auth':
          if (this.credentialFormModel.key === '' || this.credentialFormModel.new_key === '') {
            this.showToaster((0, _extends3.default)({}, this.errorToaster, { message: 'must fill out all values' }));
            return;
          }
      }

      this.triggerCredentialFormSubmit = true;
    },
    updateCredentialInfo: function updateCredentialInfo() {
      var _this2 = this;

      return (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        var loginConfig, patchPayload, loginRes, message, patchRes, _message;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                loginConfig = {};
                patchPayload = {};
                _context.t0 = _this2.formType;
                _context.next = _context.t0 === 'basic-auth' ? 5 : _context.t0 === 'key-auth' ? 8 : 11;
                break;

              case 5:
                patchPayload.password = _this2.credentialFormModel.new_password;
                loginConfig.auth = {
                  username: _this2.userInfoData.email,
                  password: _this2.credentialFormModel.password
                };
                return _context.abrupt('break', 14);

              case 8:
                patchPayload.key = _this2.credentialFormModel.new_key;
                loginConfig.headers = {
                  apikey: _this2.credentialFormModel.key
                };
                return _context.abrupt('break', 14);

              case 11:
                _this2.showToaster((0, _extends3.default)({}, _this2.errorToaster, { message: 'Unknown auth type' }));
                _this2.triggerCredentialFormSubmit = false;
                return _context.abrupt('return');

              case 14:
                _context.next = 16;
                return _Api2.default.login(loginConfig);

              case 16:
                loginRes = _context.sent;

                if (!(loginRes.status !== 200)) {
                  _context.next = 22;
                  break;
                }

                message = (0, _common.getMessageFromError)(loginRes);

                _this2.showToaster((0, _extends3.default)({}, _this2.errorToaster, { message: message }));
                _this2.triggerCredentialFormSubmit = false;
                return _context.abrupt('return');

              case 22:
                _context.next = 24;
                return _Api2.default.patch('/developer/password', patchPayload, _this2.axiosConfig);

              case 24:
                patchRes = _context.sent;

                if (!(patchRes.status !== 200)) {
                  _context.next = 30;
                  break;
                }

                _message = (0, _common.getMessageFromError)(patchRes);

                _this2.showToaster((0, _extends3.default)({}, _this2.errorToaster, { message: _message }));
                _this2.triggerCredentialFormSubmit = false;
                return _context.abrupt('return');

              case 30:

                _this2.credentialFormModel = {};
                _this2.cancelUpdateCredential();
                _this2.showToaster(_this2.successToaster);

              case 33:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this2);
      }))();
    },
    updateUserInfo: function updateUserInfo() {
      var _this3 = this;

      var emailPayload = {
        email: this.infoFormModel.email
      };

      var metaFields = (0, _keys2.default)(this.infoFormSchema.fields).filter(function (field) {
        if (field === 'email' || field === 'undefined') {
          return false;
        } else {
          return true;
        }
      });

      var metaPayload = {
        meta: {}
      };
      metaFields.forEach(function (field) {
        metaPayload['meta'][field] = _this3.infoFormModel[field];
      });

      metaPayload['meta'] = (0, _stringify2.default)(metaPayload['meta']);

      return _async2.default.parallel({
        email: function email(callback) {
          _Api2.default.patch('/developer/email', emailPayload, _this3.axiosConfig).then(function (resp) {
            callback(null, resp);
          });
        },
        meta: function meta(callback) {
          _Api2.default.put('/developer/meta', metaPayload, _this3.axiosConfig).then(function (resp) {
            callback(null, resp);
          });
        }
      }, function (_, results) {
        if (results.email.status !== 200 || results.meta.status !== 200) {
          var emailMessage = results.email.status !== 200 ? (0, _common.getMessageFromError)(results.email) : '';
          var metaMessage = results.meta.status !== 200 ? (0, _common.getMessageFromError)(results.meta) : '';
          var message = emailMessage + '\n' + metaMessage;
          _this3.triggerInfoFormSubmit = false;
          _this3.showToaster((0, _extends3.default)({}, _this3.errorToaster, { message: message }));
          return;
        }

        return _this3.fetchUserData().then(function () {
          _this3.cancelUpdateInfo();
          _this3.showToaster(_this3.successToaster);
        });
      });
    },
    fetchUserData: function fetchUserData() {
      var _this4 = this;

      return _Api2.default.get('/developer', this.axiosConfig).then(function (resp) {
        if (resp.data) {
          var meta = JSON.parse(resp.data.meta);
          (0, _keys2.default)(meta).forEach(function (key) {
            resp.data[key] = meta[key];
          });
          _this4.userInfoData = (0, _assign2.default)({}, resp.data);
          _this4.infoFormModel = (0, _assign2.default)({}, resp.data);
        }
      });
    },
    deleteUserAccount: function deleteUserAccount() {
      var _this5 = this;

      _Api2.default.delete('/developer', this.axiosConfig).then(function (resp) {
        if (resp.status !== 200) {
          var message = (0, _common.getMessageFromError)(resp);
          _this5.showToaster((0, _extends3.default)({}, _this5.errorToaster, { message: message }));
        } else {
          _this5.showModal = false;
          window.location.pathname = '/';
        }
      });
    },
    fetchExtraFields: function fetchExtraFields() {
      var _this6 = this;

      var schemaToConfigValidatorMap = {
        string: 'text',
        number: 'number'
      };

      return _Api2.default.get('/developer/meta_fields', this.axiosConfig).then(function (resp) {
        if (resp.data) {
          resp.data.forEach(function (fieldObj) {
            _this6.infoFormSchema.fields[fieldObj.title] = {
              type: 'input',
              inputType: schemaToConfigValidatorMap[fieldObj.validator.type],
              label: fieldObj.label
            };
          });
        }
      });
    },
    toggleModal: function toggleModal() {
      this.showModal = !this.showModal;
    }
  },

  computed: {
    credentialType: function credentialType() {
      switch (this.formType) {
        case 'basic-auth':
          return 'Password';
        case 'key-auth':
          return 'Key';
      }
    },
    credentialFormSchema: function credentialFormSchema() {
      switch (this.formType) {
        case 'basic-auth':
          return (0, _assign2.default)(this.basicAuthSchema, this.extraFields);
        case 'key-auth':
          return (0, _assign2.default)(this.keyAuthSchema, this.extraFields);
      }
    },
    canEditCredential: function canEditCredential() {
      return this.formType === 'basic-auth' || this.formType === 'key-auth';
    }
  },

  watch: {
    infoFormModel: {
      handler: function handler(newInfoModel) {
        if ((0, _stringify2.default)(newInfoModel) !== (0, _stringify2.default)(this.userInfoData)) {
          this.canUpdateInfo = true;
          return;
        }
        this.canUpdateInfo = false;
      },
      deep: true
    }
  }
};

/***/ }),

/***/ 906:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(46);

var _extends3 = _interopRequireDefault(_extends2);

var _Api = __webpack_require__(49);

var _Api2 = _interopRequireDefault(_Api);

var _kbutton = __webpack_require__(78);

var _kbutton2 = _interopRequireDefault(_kbutton);

var _ktoaster = __webpack_require__(108);

var _ktoaster2 = _interopRequireDefault(_ktoaster);

var _toaster = __webpack_require__(109);

var _toaster2 = _interopRequireDefault(_toaster);

var _common = __webpack_require__(17);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  name: 'ResetPassword',
  mixins: [_toaster2.default],
  components: {
    KButton: _kbutton2.default,
    KToaster: _ktoaster2.default
  },

  data: function data() {
    return {
      canSubmitEmail: false,
      emailSent: false,
      emailModel: '',
      userEmail: '',

      canSubmitPassword: false,
      resetPasswordToken: null,
      passwordChangeSuccess: false,
      passwordModel: {
        newPassword: '',
        newPasswordConfirm: ''
      },

      canSubmit: false,
      axiosConfig: { withCredentials: true },
      formType: window.K_CONFIG && window.K_CONFIG.PORTAL_AUTH,
      capitalize: _common.capitalize
    };
  },


  computed: {
    credentialType: function credentialType() {
      switch (this.formType) {
        case 'basic-auth':
          return 'password';
          break;
        case 'key-auth':
          return 'key';
          break;
      }
    },
    hasToken: function hasToken() {
      return this.resetPasswordToken;
    }
  },

  mounted: function mounted() {
    var _this = this;

    var token = (0, _common.getUrlParameter)('token');
    if (token) {
      var payload = {
        token: token
      };

      _Api2.default.post('/validate-reset', payload, this.axiosConfig).then(function (resp) {
        if (resp.status !== 200) {
          var message = 'Invalid password reset token';
          _this.showToaster((0, _extends3.default)({}, _this.errorToaster, { message: message }));
          return;
        }

        _this.resetPasswordToken = token;
      });
    }
  },


  methods: {
    resetPassword: function resetPassword() {
      var _this2 = this;

      var payload = {
        token: this.resetPasswordToken
      };

      switch (this.formType) {
        case 'basic-auth':
          payload.password = this.passwordModel.newPassword;
          break;
        case 'key-auth':
          payload.key = this.passwordModel.newPassword;
          break;
      }

      _Api2.default.post('/reset-password', payload, this.axiosConfig).then(function (resp) {
        if (resp.status !== 200) {
          var message = (0, _common.getMessageFromError)(resp);
          _this2.showToaster((0, _extends3.default)({}, _this2.errorToaster, { message: message }));
          return;
        }

        _this2.passwordChangeSuccess = true;
      });
    },
    getWorkspacedPath: function getWorkspacedPath(path) {
      var workspace = window.K_CONFIG && window.K_CONFIG.WORKSPACE;
      workspace = !workspace ? '/default' : '/' + window.K_CONFIG.WORKSPACE;

      return '' + workspace + path;
    },
    requestResetPassword: function requestResetPassword() {
      var _this3 = this;

      this.canSubmitEmail = false;
      var params = {
        email: this.emailModel
      };

      _Api2.default.post('/forgot-password', params, this.axiosConfig).then(function (resp) {
        if (resp.status !== 200) {
          var message = (0, _common.getMessageFromError)(resp);
          _this3.showToaster((0, _extends3.default)({}, _this3.errorToaster, { message: message }));
          _this3.canSubmit = true;
          return;
        }

        _this3.userEmail = _this3.emailModel;
        _this3.canSubmitEmail = true;
        _this3.emailSent = true;
      });
    }
  },

  watch: {
    passwordModel: {
      handler: function handler(newPasswordModel) {
        var isEqual = newPasswordModel.newPassword === newPasswordModel.newPasswordConfirm;
        var isEmpty = newPasswordModel.newPassword === '' && newPasswordModel.newPasswordConfirm === '';
        if (isEqual && !isEmpty) {
          this.canSubmitPassword = true;
          return;
        }
        this.canSubmitPassword = false;
      },
      deep: true
    },
    emailModel: {
      handler: function handler(newEmailModel) {
        this.canSubmitEmail = newEmailModel !== '';
      }
    }
  }
};

/***/ }),

/***/ 907:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(46);

var _extends3 = _interopRequireDefault(_extends2);

var _Api = __webpack_require__(49);

var _Api2 = _interopRequireDefault(_Api);

var _kbutton = __webpack_require__(78);

var _kbutton2 = _interopRequireDefault(_kbutton);

var _ktoaster = __webpack_require__(108);

var _ktoaster2 = _interopRequireDefault(_ktoaster);

var _toaster = __webpack_require__(109);

var _toaster2 = _interopRequireDefault(_toaster);

var _common = __webpack_require__(17);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  name: 'VerifyAccount',
  mixins: [_toaster2.default],
  components: {
    KButton: _kbutton2.default,
    KToaster: _ktoaster2.default
  },

  data: function data() {
    return {
      token: null,
      email: null,
      isLoading: false,
      verifyAccountSuccess: false,
      developerStatus: null,
      axiosConfig: { withCredentials: true },
      capitalize: _common.capitalize
    };
  },
  mounted: function mounted() {
    this.token = (0, _common.getUrlParameter)('token');
    this.email = (0, _common.getUrlParameter)('email');
  },


  methods: {
    verifyAccount: function verifyAccount() {
      var _this = this;

      this.isLoading = true;

      var payload = {
        token: this.token
      };

      _Api2.default.post('/verify-account', payload, this.axiosConfig).then(function (resp) {
        _this.isLoading = false;

        if (resp.status !== 200) {
          var message = (0, _common.getMessageFromError)(resp);
          _this.showToaster((0, _extends3.default)({}, _this.errorToaster, { message: message }));
          return;
        }

        _this.developerStatus = resp.data && resp.data.status;
        _this.verifyAccountSuccess = true;
      });
    },
    getWorkspacedPath: function getWorkspacedPath(path) {
      var workspace = window.K_CONFIG && window.K_CONFIG.WORKSPACE;
      workspace = !workspace ? '/default' : '/' + window.K_CONFIG.WORKSPACE;

      return '' + workspace + path;
    }
  }
};

/***/ }),

/***/ 908:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(46);

var _extends3 = _interopRequireDefault(_extends2);

var _Api = __webpack_require__(49);

var _Api2 = _interopRequireDefault(_Api);

var _kbutton = __webpack_require__(78);

var _kbutton2 = _interopRequireDefault(_kbutton);

var _ktoaster = __webpack_require__(108);

var _ktoaster2 = _interopRequireDefault(_ktoaster);

var _toaster = __webpack_require__(109);

var _toaster2 = _interopRequireDefault(_toaster);

var _common = __webpack_require__(17);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  name: 'ResendAccountVerification',
  mixins: [_toaster2.default],
  components: {
    KButton: _kbutton2.default,
    KToaster: _ktoaster2.default
  },

  data: function data() {
    return {
      email: "",
      isLoading: false,
      isSuccessfull: false
    };
  },


  methods: {
    resendAccountVerification: function resendAccountVerification() {
      var _this = this;

      this.isLoading = true;

      var payload = {
        email: this.email
      };

      _Api2.default.post('/resend-account-verification', payload, this.axiosConfig).then(function (resp) {
        _this.isLoading = false;

        if (resp.status !== 200) {
          var message = (0, _common.getMessageFromError)(resp);
          _this.showToaster((0, _extends3.default)({}, _this.errorToaster, { message: message }));
          return;
        }

        _this.isSuccessfull = true;
      });
    }
  }
};

/***/ }),

/***/ 909:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = __webpack_require__(46);

var _extends3 = _interopRequireDefault(_extends2);

var _Api = __webpack_require__(49);

var _Api2 = _interopRequireDefault(_Api);

var _kbutton = __webpack_require__(78);

var _kbutton2 = _interopRequireDefault(_kbutton);

var _ktoaster = __webpack_require__(108);

var _ktoaster2 = _interopRequireDefault(_ktoaster);

var _toaster = __webpack_require__(109);

var _toaster2 = _interopRequireDefault(_toaster);

var _common = __webpack_require__(17);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
  name: 'InvalidateAccountVerification',
  mixins: [_toaster2.default],
  components: {
    KButton: _kbutton2.default,
    KToaster: _ktoaster2.default
  },

  data: function data() {
    return {
      isSuccessfull: false,
      isLoading: false,
      email: null,
      token: null
    };
  },
  mounted: function mounted() {
    this.token = (0, _common.getUrlParameter)('token');
    this.email = (0, _common.getUrlParameter)('email');
  },


  methods: {
    invalidateAccountVerification: function invalidateAccountVerification() {
      var _this = this;

      this.isLoading = true;

      var payload = {
        token: this.token
      };

      _Api2.default.post('/invalidate-account-verification', payload, this.axiosConfig).then(function (resp) {
        _this.isLoading = false;

        if (resp.status !== 200) {
          var message = (0, _common.getMessageFromError)(resp);
          _this.showToaster((0, _extends3.default)({}, _this.errorToaster, { message: message }));

          return;
        }

        _this.isSuccessfull = true;
      });
    }
  },

  watch: {
    emailModel: {
      handler: function handler(newEmailModel) {
        this.canSubmitEmail = newEmailModel !== '';
      }
    }
  }
};

/***/ })

},[1831]);